*!*	Emanuele Cerlini
*!*	via mons. Torreggiani, 44 - Sabbione
*!*	42100 Reggio Emilia - Italia
*!*	ecerlini@libero.it

*!*	VFP8 SP1 e VFP9, ma compatibile fino anche VFP7 (occorre ricompilarla da una versione all'altra)
*!*	classe per velocizzare la creazione e la lettura/scrittura delle strutture API
*!*	Versione 1.10

*!*	SET COMPATIBLE deve essere OFF
*!*	SET FIXED OFF  raccomandato

*!*	per le funzioni di stampa e di spool puntare direttamente la memoria nella dichiarazione Dll
*!*	per alcune strutture RAS occorre usare la propriet nPadding o inserire aggiustamenti manuali
*!*	alle dimensioni con elementi dummy perch  impossibile fare tutto in automatico
*!*	anche altre strutture possono richiedere questi aggiustamenti

*!*	idee interessanti per ora scartate:
*!*	- restituzione del carattere invece che del numero per TCHAR e WCHAR quando singoli e non in array
*!*	- split della struttura nei membri con i soli caratteri della stringa senza nessuna conversione
*!*	- settaggio personalizzato dei membri dopo il caricamento
*!*	- compatibilit con VFP 6

*!*	scelte discutibili che avrebbero grave impatto se cambiate:
*!*	- MakeStruct() scrive sempre 2 Chr(0) invece che uno al termine delle stringhe in memoria, non ha mai dato problemi ma non  garantito
*!*	Si risolve scrivendo nel membro con WriteMemory(cStringa+Chr(0))

*!*	aprile 2004

*!*	agg. giugno 2004 per la scrittura diretta nella memoria WriteMemory, FreeMemory, GetMemorySize
*!*	rese pubbliche funzioni di conversione numeri
*!*	aggiunte propriet lAutoArray e lAutoMemory per maggiore flessibilit
*!*	Destroy pulisce la memoria chiamando ResetData

*!*	agg. luglio 2004 caricamento diretto strutture interne per numero indice
*!*	implementato caricamento per array API di dati o strutture con InitAPIArray
*!*	tolte propriet cData* e cInternalStruct per risparmiare memoria su pi oggetti creati
*!*	aggiunta funzione DataTypes per tipi di dati supportati
*!*	aggiunto parametro lAllZero a MakeStruct per velocizzare strutture vuote
*!*	aggiunto parametro nMode a ClipStruct per avere pi informazioni sui dati e rilevare errori di riconoscimento

*!*	agg. agosto 2004 aggiunta propriet lUnknownAsStruct per creazione automatica oggetto rAPIdStructure nei dati non riconosciuti oppure numerico di 4 bytes
*!*	tolte macro-sostituzioni di troppo e testato su Win98 con perfezionamenti
*!*	corretto grave bug pulizia memoria in ResetData e Destroy ma solo con lAutoMemory=.F.
*!*	e in lettura matrici caratteri se piene e LPWSTR
*!*	cambio RtlMoveMemory con Sys(2600), anche se io non sono un "advanced programmer"...
*!*	corretto bug per SplitStruct con sub-strutture se prima non  stato chiamato MakeStruct o CalculateBytes
*!*	aggiunto blocco memoria in lettura della stessa per tentare di evitare che la classe sovrascriva il buffer
*!*	aggiunta ereditariet propriet: settando (es.: lAutoMemory=.F.) nella principale, tutte le classi delle sub-strutture ricevono lo stesso
*!*	dove possibile cambio funzioni Global con Heap: sono pi veloci
*!*	riscritta ResetData, velocizzando anche i caricamenti
*!*	corretto bug per valori negativi in input

*!*	agg. settembre 2004 aggiunta conversione valori Null in input
*!*	aggiunto supporto per strutture in bit (terminanti con : 1; ...)
*!*	aggiunto parametro nLength a MakeStruct per avere stringhe pi lunghe della struttura
*!*	aumentate dimensioni minime stringa di memoria leggibile non specificate, ora a 65536
*!*	ora lUnknownAsStruct ha effetto solo sulle classi delle sub-strutture se si inizializza un array API
*!*	aggiunta funzione AllocateMemory pi che altro come utilit

*!*	agg. ottobre 2004 aggiunto parametro lAllInCharString a SplitStruct per leggere tutti i dati dalla stringa di certe funzioni API, evitando inaffidabilit memoria

*!*	agg. novembre 2004 risolto bug minimo in ClipMembers se fallisce una sub-struttura

*!*	agg. dicembre 2004 corretto ReadMemory se la memoria letta senza dimensioni non comprende un Chr(0)

*!*	agg. febbraio 2005 preservazione delle stringhe di testo in memoria anche dopo MakeStruct
*!*	aggiunta quindi funzione GetPtr per restituire il pointer dal nome della propriet sia per le scritte che per le lette
*!*	ora  possibile chiamare le strutture interne anche per nome non solo per indice da LoadCdef e LoadVBDef
*!*	corretto bug che impediva creazione di arrays di puntatori, ma chi le usa?...
*!*	rivista tutta la procedura per le strutture interne velocizzandola
*!*	cambiate tutte le Hidden in Protected, tanto  in un .prg...

*!*	agg. marzo 2005 piccola correzione alla procedura di lAllInCharString perch non sempre riusciva a leggere corretto...
*!*	e anche a FreeMemory e GetMemorySize
*!*	aggiunta propriet nPadding che gestisce le dimensioni della struttura in generale
*!*	eliminazione righe commento da strutture C con ";" dopo segno commento e supporto per IN e OUT iniziali e * come puntatore
*!*	aggiunto totale bytes a ClipMembers() con valore 2 o 3
*!*	aggiunta propriet vStopAt come supporto per strutture multiversioni
*!*	il problema delle strutture adattate si risolve con una pi corretta dichiarazione Dll... Lascio i supporti come obsoleti
*!*	aggiunta propriet cDoubleNullList e parametro lDoubleNull a ReadMemory per arrivare a leggere le stringhe che termina con 2 caratteri null
*!*	aggiunta la funzione di utilit FlagTest per sapere se un Flag di bit  presente nel risultato

*!*	agg. aprile 2005 corretta piccola imprecisione sugli arrotondamenti in Float2Char quando 4 bytes
*!*	aggiornate alla versione 9 le 2 funzioni di Float. Non posso fare altrettanto per le Num* perhc salterebbe il discorso dell'Unsigned specie per il 64bit
*!*	aggiunto supporto strutture C su unica linea
*!*	attivata preservazione di tutti i caratteri in un'array automatica ma solo strutture C e tipo dati BYTE
*!*	aggiunto parametro lAnsi2Wide a LoadCDef per la conversione da una struttura definita ANSI a Unicode
*!*	aggiunta conversione Unicode opzionale con la propriet lAutoUnicodeConv
*!*	rivista anche ReadMemory che era con troppe pezze diverse

*!*	agg. febbraio 2006 aggiunto parametro nMemAddr a WriteMemory per scrivere la stringa nel punto indicato (potenzialmente pericoloso)
*!*	aggiunto il supporto per pi elementi nella stessa riga per le strutture C

*!*	agg. marzo 2006 rimosso definitivamente il parametero obsoleto lAllInCharString di MakeStruct() e tutto il suo supporto
*!*	aggiunta propriet cExcludeList per caricare le strutture Union intere e specificare quali elementi non elaborare
*!*	corretto bug minimo su ereditariet di cDoubleNullList nelle arrray

*!*	agg. aprile 2006 rivisto, con molte riserve il calcolo dei bytes per i membri in bits
*!*	aggiunta propriet lAutoFar per totale flessibilit coi CHAR FAR *
*!*	aggiunto supporto per array moltiplicate nelle strutture C (es.: byte m[4][4])
*!*	corretto bug nelle array di BYTE quando .lAutoArray  .T.

*!*	SDG (nel mio piccolo...)

*!*	costanti
*!*	errori
#DEFINE ERR_NO_ERROR 0 && nessun errore
#DEFINE ERR_BAD_PARAMS -11 && passati parametri non corretti
#DEFINE ERR_DEF_NOT_LOADED -301 && definizione di struttura non caricata
#DEFINE ERR_DEF_ALREADY_LOADED -302 && definizione di struttura gi caricata
#DEFINE ERR_INVALID_DEF -303 && definizione di struttura non valida
#DEFINE ERR_INVALID_DEF_NAME -304 && nome struttura non rilevato
#DEFINE ERR_INVALID_ARRAY -305 && array nella struttura non valida
#DEFINE ERR_NO_MEMBERS -306 && nessun membro della struttura caricato
#DEFINE ERR_INVALID_DATA_IN -307 && dato non corrispondente in input di un membro
#DEFINE ERR_2_LEVEL_STRUCT -308 && errore in una struttura di livello secondario
#DEFINE ERR_DLL_EXCEPTION -309 && errore nelle DLL per la lettura/scrittura della memoria
#DEFINE ERR_NO_STORED_POINTERS -310 && nessun puntatore memorizzato (queste sono di GetPtr)
#DEFINE ERR_MEMBER_NOT_FOUND -311 && nome membro inesistente
#DEFINE ERR_BAD_MEMBER_INDEX -312 && indice membro errato
#DEFINE ERR_NO_POINTER -313 && non  un puntatore
#DEFINE ERR_MEMORY_NOT_POINTED -314 && la memoria non  puntata

*!* tipi di dati supportati per DataTypes()
#DEFINE DATA_8 "8"
#DEFINE DATA_16 "16"
#DEFINE DATA_32 "32"
#DEFINE DATA_64 "64"
#DEFINE DATA_VB "VB"
#DEFINE DATA_INT_STRUCT "IS"

*!* indice strutture interne, come posizione nella stringa
#DEFINE IDX_FILETIME 1
#DEFINE IDX_POINT 2
#DEFINE IDX_POINTL 3
#DEFINE IDX_RECT 4
#DEFINE IDX_RECTL 5
#DEFINE IDX_SYSTEMTIME 6

*!*	nomi strutture interne
#DEFINE FT_S "FILETIME"
#DEFINE P_S "POINT"
#DEFINE PL_S "POINTL"
#DEFINE R_S "RECT"
#DEFINE RL_S "RECTL"
#DEFINE ST_S "SYSTEMTIME"
*!*	e 64 bit
#DEFINE LI_S "LARGE_INTEGER"
#DEFINE ULI_S "ULARGE_INTEGER"

*!* codici parametro nMode per ClipStruct()
#DEFINE CLIP_NORMAL 0
#DEFINE CLIP_FORCE 1
#DEFINE CLIP_INFO 2
#DEFINE CLIP_FORCE_AND_INFO CLIP_FORCE+CLIP_INFO && 3

*!*	invio a capo
#IfnDef CRLF
#DEFINE CRLF CHR(13)+CHR(10)
#ENDIF
*!*	tabulazione
#IfnDef TABU && Tab troppo simile a parola-chiave Fox
#DEFINE TABU CHR(9)
#ENDIF

*!*	lunghezza riga memo
#DEFINE LEN_LINE 255

*!*	tipi di dati interni
#DEFINE INT_STRUCT 0
#DEFINE EXT_STRUCT 1
#DEFINE BOOL_C 2
#DEFINE DOUBLE_C 3
#DEFINE DWORD_C 4
#DEFINE FLOAT_C 5
#DEFINE QWORD_C 6
#DEFINE TCHAR_C 7
#DEFINE WCHAR_C 8
#DEFINE WORD_C 9
#DEFINE CHARFAR_C 10
#DEFINE TCHAR_C_M 11 && non pi usato
#DEFINE WCHAR_C_M 12 && non pi usato
#DEFINE BYTE_C 13

*!*	qualifiche tipi dato
#DEFINE BIT_T "B"
#DEFINE CHAR_T "C"
#DEFINE FLOAT_T "F"
#DEFINE LOGIC_T "L"
#DEFINE NUM_T "N"
#DEFINE STRUCT_T "S"

*!*	membri array interna per cicli FOR
#DEFINE M_NAME .aStructMembers[m.i,1]
#DEFINE M_DATA .aStructMembers[m.i,2]
#DEFINE M_LEN .aStructMembers[m.i,3]
#DEFINE M_NUM .aStructMembers[m.i,4]
#DEFINE M_SIGNED .aStructMembers[m.i,5]
#DEFINE M_IN .aStructMembers[m.i,6]
#DEFINE M_OUT .aStructMembers[m.i,7]
#DEFINE M_MEMORY .aStructMembers[m.i,8]
#DEFINE M_ARRAY .aStructMembers[m.i,9]

#DEFINE M_POINTER_IN .aPtrsIn[m.i] && viene aggiunto solo se necessario
#DEFINE M_POINTER_OUT .aPtrsOut[m.i]

*!*	aggiunta per array di propriet, in ciclo FOR
#DEFINE ADD_ARRAY "["+LTRIM(STR(m.ii))+"]"

*!*	controllo ultimo elemento da elaborare
#DEFINE LAST_ELEMENT IIF(EMPTY(.vStopAt), .nElements, .GetLast())

*!*	fissi per float IEEE
#DEFINE DBL_BIAS_EXP 1023
#DEFINE FTL_BIAS_EXP 127
#DEFINE DBL_L_EXP 11
#DEFINE FTL_L_EXP 8
#DEFINE DBL_L_MANT 52
#DEFINE FTL_L_MANT 23
#DEFINE DBL_DECIM 15
#DEFINE FLT_DECIM 6

*!*	termine di stringa
#DEFINE A_END CHR(0) && ansi
#DEFINE U_END CHR(0)+CHR(0) && unicode

*!*	punto e punto e virgola
#DEFINE DOT "."
#DEFINE SEMICOLON ";"

*!*	per array API
#DEFINE TOP_API_ARRAY "struct _APIARRAY {"
#DEFINE END_API_ARRAY "} APIARRAY"

*!*	 massimo caratteri per stringa di variabile
#DEFINE MAX_CHAR_VAR 65536
#DEFINE MAX_CHAR_VAR_TOT 16777184

*!*	lunghezza segmento memoria
#DEFINE MEMORY_SEGMENT 128 && lasciarlo sempre numero pari!!!

*!*	inizializzazione a 0 della memoria allocata
#DEFINE HEAP_ZERO_MEMORY                0x00000008

*!*	parte di un bit sul byte
#DEFINE BIT_PART 0.125 && 1/8 bit/byte
#DEFINE N_BIT 8

*!*	commento C
#DEFINE C_COMMENT "//"

*!*	per commenti
#DEFINE CMT_FLAG " &"+"& " && salto errore di compilazione
#DEFINE CMT_COMMA ", "
#DEFINE CMT_INPUT "Input: "
#DEFINE CMT_OUTPUT "Output: "
#DEFINE CMT_ADD_TEXT "/Text"
#DEFINE CMT_NUMERIC "Numeric"
#DEFINE CMT_LOGICAL "Logical"
#DEFINE CMT_TEXT "Text"
#DEFINE CMT_FLOAT CMT_NUMERIC+CMT_COMMA+"Floating-point"
#DEFINE CMT_ARRAY CMT_NUMERIC+CMT_COMMA+"Array"
#DEFINE CMT_SIGNED "Signed"
#DEFINE CMT_UNSIGNED "Unsigned"
#DEFINE CMT_MEMORY "Memory"
#DEFINE CMT_UNICODE "Unicode"
#DEFINE CMT_STRUCTURE "Structure"
#DEFINE CMT_NOT_LOADED " (not loaded)"
#DEFINE CMT_BYTES " bytes"
#DEFINE CMT_BYTE " byte"
#DEFINE CMT_1_BYTES " 1 bytes"
#DEFINE CMT_1_BYTE " 1 byte"
#DEFINE CMT_BITS " bits"
#DEFINE CMT_BIT " bit"
#DEFINE CMT_TOTAL "*!*	Total: "
#DEFINE CMT_WITH "With "
#DEFINE CMT_ENDWITH "EndWith"

*!*	GetPtr fallisce
#DEFINE GETPTR_FAILS 0

*!*	arrotondamenti strutture
#DEFINE PADDING_AUTO -1 && al multiplo di 4 appena superiore
#DEFINE PADDING_NONE 0 && nessuno

*!*	tipi dati con particolarit
*!*	pointers in memoria (punto solo stringhe ed escludo i PBYTE perch non sono terminanti con Chr(0) ... spero sia giusto!)
#DEFINE KN_POINTERS "LPCSTR","LPCTSTR","LPCWSTR","LPSTR", ;
	"LPTSTR","LPWSTR","PCHAR","PCSTR","PCTSTR", ;
	"PCWCH","PCWSTR","PSTR","PTCHAR", "PTSTR", ;
	"PUCHAR","PWCHAR","PWSTR"
*!*	booleani
#DEFINE KN_BOOLEANS "BOOL","BOOLEAN"
*!*	64 bit
#DEFINE KN_LONG64 "INT64","LONG64","LONGLONG"
*!*	possibili negativi
#DEFINE KN_SIGNED "CHAR","INT","INT32","INT64", ;
	"INT_PTR","LONG","LONG32","LONG64","LONGLONG", ;
	"LONG_PTR","PSHORT","SSIZE_T"


*!* inizio definizione della classe

*!* ogni tipo di dato separato da uno spazio e maiuscolo
*!* i tipi di dati sono presi da MSDN -> Platform SDK: Win32 API -> Data Types
*!* aggiunti DOUBLE (float a precisione doppia) e DWORDLONG, QWORD, BCHAR
*!* tolti alcuni strani
DEFINE CLASS rAPIdStructure AS CUSTOM
	PROTECTED nElements, nExMemoWidth, nHeap, lMakeIsLast
	PROTECTED aStructMembers[1,9], aPtrsIn[1], aPtrsOut[1]

	cStructure=""
	lAllowIntStruct=.T.
	lBoolNumeric=.T.
	nError=0
	nItemInError = 0
	lSplit64bit=.T.
	lAutoArray=.T.
	lAutoMemory=.T.
	lUnknownAsStruct=.T.
	vStopAt=0
	nPadding=0
	cDoubleNullList=""
	lAutoUnicodeConv=.T.
	cExcludeList=""
	lAutoFar=.T.
	nElements=0
	nHeap=0
	lMakeIsLast=.F.
	nExMemoWidth=SET("Memowidth")
	oPChar = NULL

	PROCEDURE DataTypes
*!* restituisce i tipi di dati supportati
	LPARAMETERS cType

*!*	    This.nError=ERR_NO_ERROR
	IF EMPTY(m.cType) OR VARTYPE(m.cType)<>"C"
		IF VARTYPE(m.cType)="N" && perdono errore
			cType=IIF(INLIST(m.cType,8,16,32,64), LTRIM(STR(m.cType)), "")
		ELSE
*!*	            This.nError=ERR_BAD_PARAMS
*!*	            Return ""
			m.cType=DATA_INT_STRUCT
		ENDIF

	ENDIF

	PRIVATE cResult
	LOCAL cResult AS STRING

	cResult=""

	DO CASE
	CASE m.cType=DATA_8
		cResult="BYTE BCHAR CHAR TBYTE TCHAR UCHAR"
	CASE m.cType=DATA_16
		cResult="ATOM LANGID SHORT USHORT WCHAR WORD"
	CASE m.cType=DATA_32
		cResult="BOOL BOOLEAN COLORREF DWORD DWORD_PTR DWORD32"+ ;
			" FLOAT HACCEL HANDLE HBITMAP HBRUSH"+ ;
			" HCOLORSPACE HCONV HCONVLIST HCURSOR HDC HDDEDATA HDESK"+ ;
			" HDROP HDWP HENHMETAFILE HFILE HFONT HGDIOBJ HGLOBAL HHOOK"+ ;
			" HICON HIMAGELIST HIMC HINSTANCE HKEY HKL HLOCAL HMENU"+ ;
			" HMETAFILE HMODULE HMONITOR HPALETTE HPEN HRGN HRSRC"+ ;
			" HSZ HWINSTA HWND INT INT_PTR INT32 IPADDR IPMASK"+ ;
			" LCID LCSCSTYPE LCSGAMUTMATCH LCTYPE LONG LONG_PTR"+ ;
			" LONG32 LPARAM LPBOOL LPBYTE LPCOLORREF"+ ;
			" LPCSTR LPCTSTR LPCVOID LPCWSTR LPDWORD"+ ;
			" LPHANDLE LPINT LPLONG LPSTR LPTSTR LPVOID LPWORD LPWSTR"+ ;
			" LRESULT PBOOL PBOOLEAN PBYTE PCHAR"+ ;
			" PCSTR PCTSTR PCWCH PCWSTR PDWORD PFLOAT PHANDLE PHKEY PINT"+ ;
			" PLCID PLONG PSHORT PSTR PTBYTE"+ ;
			" PTCHAR PTSTR PUCHAR PUINT PULONG PUSHORT PVOID PWCHAR PWORD"+ ;
			" PWSTR REGSAM SC_HANDLE SC_LOCK SERVICE_STATUS_HANDLE SIZE_T"+ ;
			" SSIZE_T UINT UINT_PTR UINT32 ULONG"+ ;
			" ULONG_PTR ULONG32 USHORT VOID WPARAM"
	CASE m.cType=DATA_64
		cResult="DOUBLE DWORD64 DWORDLONG INT64 LONG64 LONGLONG QWORD UINT64 ULONG64 ULONGLONG"
	CASE UPPER(m.cType)=DATA_VB
		cResult="BOOLEAN BYTE DOUBLE INTEGER LONG STRING SINGLE"
	OTHERWISE && DATA_INT_STRUCT
		cResult="FILETIME POINT POINTL RECT RECTL SYSTEMTIME"
	ENDCASE

	RETURN m.cResult

	ENDPROC && fine DataTypes

	FUNCTION LoadCDef
*!* carica la definizione della struttura in C
	LPARAMETERS cDefStruct, lAnsi2Wide

	WITH THIS
		.nError=ERR_NO_ERROR

		IF .nElements>0 && gi caricato
			.nError=ERR_DEF_ALREADY_LOADED
			RETURN .F.
		ENDIF

*!*	permetto caricamento di strutture interne per nome o indice
		IF EMPTY(m.cDefStruct) OR VARTYPE(m.cDefStruct)<>"C"
			IF VARTYPE(m.cDefStruct)="N" AND BETWEEN(m.cDefStruct, 1, GETWORDCOUNT(.DataTypes(DATA_INT_STRUCT)))
				RETURN .InternalStruct(GETWORDNUM(.DataTypes(DATA_INT_STRUCT), INT(m.cDefStruct)))
			ELSE
				.nError=ERR_BAD_PARAMS
				RETURN .F.
			ENDIF
		ENDIF

		IF GETWORDCOUNT(m.cDefStruct)=1
			IF " "+UPPER(m.cDefStruct)+" "$" "+.DataTypes(DATA_INT_STRUCT)+" " OR ISNULL(.cStructure)
				RETURN .InternalStruct(m.cDefStruct)
			ELSE
				.nError=ERR_INVALID_DEF
				RETURN .F.
			ENDIF
		ENDIF

		.nExMemoWidth=SET("Memowidth")
		SET MEMOWIDTH TO LEN_LINE

		cDefStruct=ALLTRIM(m.cDefStruct)

		PRIVATE i, ii, cRow, cTempStruct, nArr, nTempPos1, nTempPos2, ;
			nFar, nSigned, cIntStruct, nBit, lAsterisk, cMoreElem

		LOCAL cRow AS STRING, ;
			cTempStruct AS STRING, ;
			nArr AS NUMBER, ;
			nTempPos1 AS NUMBER, ;
			nTempPos2 AS NUMBER, ;
			nFar AS NUMBER, ;
			nSigned AS NUMBER, ;
			cIntStruct AS STRING, ;
			cBit AS STRING, ;
			lAsterisk AS Logical, ;
			cMoreElem AS CHARACTER

		cTempStruct=LOWER(m.cDefStruct)

*!* controllo minimo che sia comando C valido
		nTempPos1= AT("{",m.cTempStruct)
		nTempPos2= AT("struct",m.cTempStruct)

		IF m.nTempPos2=0 OR m.nTempPos1<m.nTempPos2
			.nError=ERR_INVALID_DEF
			RETURN .F.
		ENDIF

*!* controllo e nome struttura
		nTempPos2=RAT("}",m.cDefStruct)
		cTempStruct=SUBSTR(m.cDefStruct, m.nTempPos2+1)
		cTempStruct=ALLTRIM(CHRTRAN(m.cTempStruct," ,;:*"+CRLF," ")) && "_" tolto qui
		IF GETWORDCOUNT(m.cTempStruct)>0
			.cStructure=GETWORDNUM(m.cTempStruct,1)
		ELSE && se non  alla fine deve essere all'inizio un qualche identificativo
			cTempStruct=LEFT(m.cDefStruct, m.nTempPos1-1)
			.cStructure=GETWORDNUM(m.cTempStruct,GETWORDCOUNT(m.cTempStruct))
		ENDIF
		.cStructure=UPPER(.cStructure)
		IF LEFT(.cStructure, 1)="_" && solo se all'inizio
			.cStructure=SUBSTR(.cStructure, 2)
		ENDIF

		IF EMPTY(.cStructure)
			.nError=ERR_INVALID_DEF_NAME
			RETURN .F.
		ENDIF

*!* cos conservo anche mantenimento M/m
		cDefStruct=SUBSTR(m.cDefStruct, m.nTempPos1+1, m.nTempPos2-m.nTempPos1-1)

		cTempStruct=""
*!*	qui un primo giro per verificare le linee con pi comandi
		FOR ii=1 TO MEMLINES(m.cDefStruct)
			cRow=ALLTRIM(MLINE(m.cDefStruct,m.ii))
			IF !SEMICOLON$m.cRow
				LOOP
			ENDIF

			nTempPos1=AT(C_COMMENT, m.cRow)
			IF m.nTempPos1>0
				cRow=LEFT(m.cRow, m.nTempPos1-1)
			ENDIF

			IF GETWORDNUM(m.cRow, 1)="#" OR GETWORDCOUNT(m.cRow)<2
				LOOP
			ENDIF

			IF OCCURS(SEMICOLON, m.cRow)>1 OR RAT(SEMICOLON, m.cRow)<>LEN(m.cRow)
				cRow=STRTRAN(m.cRow, SEMICOLON, SEMICOLON+CRLF)
			ENDIF

			IF NOT "{"+CRLF$m.cRow
				cRow=STRTRAN(m.cRow, "{", "{"+CRLF)
			ENDIF
			IF NOT CRLF+"}"$m.cRow
				cRow=STRTRAN(m.cRow, "}", CRLF+"}")
			ENDIF

			cTempStruct=m.cTempStruct+m.cRow+CRLF

		NEXT ii

		cDefStruct=m.cTempStruct
		i=0 && incremento righe array

		IF TABU$m.cDefStruct
			cDefStruct=STRTRAN(m.cDefStruct, TABU, " ")
		ENDIF

*!* vero lavoro di riconoscimento dati
		FOR ii=1 TO MEMLINES(m.cDefStruct)
			nArr=0
			cBit=""

			cRow=IIF(EMPTY(m.cMoreElem), MLINE(m.cDefStruct, m.ii), m.cMoreElem)

			IF !SEMICOLON$m.cRow
				LOOP
			ENDIF

			cRow=ALLTRIM(STREXTRACT(m.cRow, "", SEMICOLON))

			IF INLIST(m.cRow,"{","}","#","/") ;
					OR EMPTY(m.cRow) ;
					OR GETWORDCOUNT(m.cRow)<2
				LOOP
			ENDIF
			IF ":"$m.cRow
				cRow=STRTRAN(m.cRow, ":", " :")
			ENDIF

*!*	verifica e aggiustamento di pi elementi nella stessa riga
			nTempPos2= AT(",", m.cRow)
			IF m.nTempPos2=0
				cMoreElem="" && obbligato a vuotarla sempre ma non rallenta p di tanto
			ELSE
				cMoreElem=SUBSTR(m.cRow, m.nTempPos2+1)
				cRow=LEFT(m.cRow, m.nTempPos2-1)
			ENDIF

			nTempPos1=OCCURS("[", m.cRow)
			IF m.nTempPos1>0
				nArr=INT(VAL(ALLTRIM(STREXTRACT(m.cRow, "[", "]"))))

				IF m.nTempPos1>1 && supporto per moltiplicazione di elementi
					PRIVATE na
					FOR na=2 TO m.nTempPos1
						nArr=m.nArr * (INT(VAL(ALLTRIM(STREXTRACT(m.cRow,"[","]", m.na)))))
					NEXT na
				ENDIF

				IF m.nArr>0
*!* rimuovi dalla parentesi [, ma salvati prima eventuali rarissimi elementi nella stessa riga
					cRow=STREXTRACT(m.cRow, "", "[")
					IF GETWORDCOUNT(m.cRow)<2 && sarebbe errore anche in C, ma io ignoro solo la riga

						IF !EMPTY(m.cMoreElem)
							cMoreElem=m.cRow+" "+m.cMoreElem+" "+SEMICOLON
							ii=m.ii-1 && attento a questo in fondo
						ENDIF
						LOOP
					ENDIF
				ELSE
					.ResetClass()
					.nError=ERR_INVALID_ARRAY
					RETURN .F.
				ENDIF
			ENDIF

*!* caricamento matrice interna
			i=m.i+1
			IF m.i>1
				DIMENSION M_ARRAY && elemento massimo .aStructMembers[m.i,9]
			ENDIF

			lAsterisk=("*"$m.cRow) && questo dice dire puntatore, ne valuto solo uno
			IF m.lAsterisk
				cRow=CHRTRAN(m.cRow, "*", " ")
			ENDIF

*!* guarda che non sia con finale tipo :8
			nTempPos1= AT(":", m.cRow)
			IF nTempPos1=0
*!* nome elemento
				M_NAME=GETWORDNUM(m.cRow,GETWORDCOUNT(m.cRow))
			ELSE
				cBit=ALLTRIM(SUBSTR(m.cRow, m.nTempPos1+1))
				cRow=ALLTRIM(LEFT(m.cRow, m.nTempPos1-1))
				M_NAME=GETWORDNUM(m.cRow,GETWORDCOUNT(m.cRow))
			ENDIF

			cRow=UPPER(LEFT(m.cRow,AT(" "+M_NAME,m.cRow)-1))

			IF !EMPTY(m.cMoreElem)
				cMoreElem=m.cRow+" "+m.cMoreElem+" "+SEMICOLON
				ii=m.ii-1 && attento a questo in fondo
			ENDIF

*!* riconoscimento del tipo di dato
			nFar=0
			nSigned=0
			IF GETWORDCOUNT(m.cRow)>1
				cRow=" "+m.cRow+" "
				DO CASE
				CASE " SIGNED "$m.cRow
					nSigned= -1
					cRow=STRTRAN(m.cRow," SIGNED "," ")
				CASE " UNSIGNED "$m.cRow
					nSigned= +1
					cRow=STRTRAN(m.cRow," UNSIGNED "," ")
				ENDCASE

				nFar=OCCURS(" FAR ", m.cRow) && 0, 1 o 2

				IF m.nFar>0
					cRow=STRTRAN(m.cRow," FAR "," ")
				ENDIF

*!* elimina CONST, STRUCT, OPTIONAL, IN e OUT perch non supportato o automatico
				IF " CONST "$m.cRow
					cRow=STRTRAN(m.cRow," CONST "," ", 1, 1)
				ENDIF
				IF " STRUCT "$m.cRow
					cRow=STRTRAN(m.cRow," STRUCT "," ", 1, 1)
				ENDIF
				IF " OPTIONAL "$m.cRow
					cRow=STRTRAN(m.cRow," OPTIONAL "," ", 1, 1)
				ENDIF
				IF " IN "$m.cRow
					cRow=STRTRAN(m.cRow," IN "," ", 1, 1)
				ENDIF
				IF " OUT "$m.cRow
					cRow=STRTRAN(m.cRow," OUT "," ", 1, 1)
				ENDIF

				cRow=ALLTRIM(m.cRow)
			ENDIF

*!* ora la prima parola deve essere quella del dato
			cTempStruct=UPPER(GETWORDNUM(m.cRow,1))

*!* rilevamento dati generici della parola
			M_IN=NUM_T
			M_OUT=NUM_T

			DO CASE
			CASE " "+m.cTempStruct+" "$" "+.DataTypes(DATA_8)+" "
				M_LEN=1
				M_DATA=IIF(m.cTempStruct<>"BYTE", TCHAR_C, BYTE_C)
				IF m.nArr>0 AND .lAutoArray=.T.
					M_IN=CHAR_T && se collezione di caratteri o dichiarati
					M_OUT=CHAR_T
				ENDIF

			CASE " "+m.cTempStruct+" "$" "+.DataTypes(DATA_16)+" "
				M_DATA=WORD_C
				M_LEN=2
				IF m.cTempStruct="WCHAR"
					M_DATA=WCHAR_C
					IF m.nArr>0 AND .lAutoArray=.T.
						M_IN=CHAR_T
						M_OUT=CHAR_T
					ENDIF
				ENDIF

			CASE " "+m.cTempStruct+" "$" "+.DataTypes(DATA_32)+" "
				M_DATA=DWORD_C
				M_LEN=4

				DO CASE

*!* pointers in memoria (punto solo stringhe ed escludo i PBYTE perch non sono terminanti con Chr(0) ... spero sia giusto!)
				CASE INLIST(m.cTempStruct, KN_POINTERS)
					M_OUT=CHAR_T
					M_MEMORY=.T.

					M_DATA=IIF("W"$m.cTempStruct, WCHAR_C, TCHAR_C)

				CASE INLIST(m.cTempStruct, KN_BOOLEANS)
					IF !.lBoolNumeric
						M_DATA=BOOL_C
						M_IN=LOGIC_T
						M_OUT=LOGIC_T
					ELSE
						M_DATA=DWORD_C
					ENDIF
				CASE m.cTempStruct="FLOAT"
					M_DATA=FLOAT_C
					M_IN=FLOAT_T
					M_OUT=FLOAT_T
				ENDCASE

			CASE " "+m.cTempStruct+" "$" "+.DataTypes(DATA_64)+" "
				M_DATA=QWORD_C
				M_LEN=8
				IF m.cTempStruct="DOUBLE"
					M_DATA=DOUBLE_C
					M_IN=FLOAT_T
					M_OUT=FLOAT_T
				ELSE
					IF .lSplit64bit
						M_IN=STRUCT_T
						M_DATA=INT_STRUCT
						IF INLIST(m.cTempStruct, KN_LONG64)
							M_OUT="LARGE_INTEGER"
						ELSE
							M_OUT="ULARGE_INTEGER"
						ENDIF
					ENDIF

				ENDIF

			OTHERWISE
				M_IN=STRUCT_T
				M_LEN=0
				IF " "+m.cTempStruct+" "$" "+.DataTypes(DATA_INT_STRUCT)+" "
					M_DATA=INT_STRUCT
					M_OUT=m.cTempStruct
				ELSE
					IF .lUnknownAsStruct=.T.
						M_DATA=EXT_STRUCT
						M_OUT=STRUCT_T
					ELSE
						M_IN=NUM_T
						M_DATA=DWORD_C
						M_LEN=4
					ENDIF

				ENDIF
			ENDCASE

			IF m.nSigned=0
				M_SIGNED=INLIST(m.cTempStruct, KN_SIGNED) && forse per i _PTR non lo  e neanche per i CHAR
			ELSE
				M_SIGNED=(m.nSigned=-1)
			ENDIF

			IF m.nArr>0 && gestione array
				IF !INLIST(M_DATA, TCHAR_C, WCHAR_C, BYTE_C) ;
						OR M_MEMORY ;
						OR .lAutoArray=.F.
					M_ARRAY=.T.
				ENDIF
				M_NUM=m.nArr
			ELSE
				M_NUM=1
			ENDIF

			IF m.nFar>0 OR m.lAsterisk && gestione FAR o asterischi
				M_IN=NUM_T
				M_LEN=4
				M_SIGNED=.F.
				M_OUT=NUM_T

				IF .lAutoFar AND m.nFar>0 AND M_DATA=TCHAR_C && solo per caratteri elaboro il FAR
					M_DATA=CHARFAR_C
					M_MEMORY=.T.
					IF m.nFar=1
						M_ARRAY=.F.
						M_OUT=CHAR_T && uguale a LPSTR
					ELSE
						M_ARRAY=.T.
						M_NUM=1 && elementi indefiniti, ma uno sicuro
					ENDIF
				ELSE
					M_DATA=DWORD_C && provo a segnarlo anche per altri tipi	e per l'asterisco
				ENDIF
			ENDIF

			IF INLIST(M_IN, NUM_T, LOGIC_T) AND INLIST(M_OUT, NUM_T, LOGIC_T) ;
					AND VAL(m.cBit)>0 && nei casi di strutture divise per bit
*!*	forzo l'elaborazione a parte, visto che i membri in bit sono una rarit
				M_IN=BIT_T
				M_OUT=m.cBit
*!*					M_ARRAY=.F.
			ENDIF

*!* qui si decide solo il nome: propriet e valori li sistema ResetData()
			IF PEMSTATUS(THIS, M_NAME ,5) ;
					OR (m.i>1 AND ASCAN(.aStructMembers, M_NAME, 1, m.i-1, 1, 15)>0)
				M_NAME="_"+M_NAME
			ENDIF

		NEXT ii

		IF !EMPTY(.aStructMembers[1,1]) && caricato almeno un elemento
			.nElements=ALEN(.aStructMembers,1)

			IF VARTYPE(m.lAnsi2Wide)="L" AND m.lAnsi2Wide && conversione da ANSI a Unicode
				FOR i=1 TO .nElements
					IF M_DATA=TCHAR_C
						M_DATA=WCHAR_C
						IF !M_MEMORY
							M_LEN=2
							M_SIGNED=.F.
						ENDIF
					ENDIF
				NEXT
			ENDIF

			.ResetData()
		ELSE
			.ResetClass()
			.nError=ERR_NO_MEMBERS
			RETURN .F.
		ENDIF

		SET MEMOWIDTH TO (.nExMemoWidth)

	ENDWITH

	ENDFUNC

	FUNCTION LoadVBDef
*!* carica da una definizione di struttura di Visual Basic
	LPARAMETERS cDefStruct
	WITH THIS
		.nError=ERR_NO_ERROR

		IF .nElements>0 && gi caricato
			.nError=ERR_DEF_ALREADY_LOADED
			RETURN .F.
		ENDIF

*!*	anche qui strutture interne per nome o indice ma chiama LoadCDef
		IF EMPTY(m.cDefStruct) OR VARTYPE(m.cDefStruct)<>"C"
			IF VARTYPE(m.cDefStruct)="N" AND BETWEEN(m.cDefStruct, 1, GETWORDCOUNT(.DataTypes(DATA_INT_STRUCT)))
				RETURN .InternalStruct(GETWORDNUM(.DataTypes(DATA_INT_STRUCT), INT(m.cDefStruct)))
			ELSE
				.nError=ERR_BAD_PARAMS
				RETURN .F.
			ENDIF
		ENDIF

		IF GETWORDCOUNT(m.cDefStruct)=1
			IF " "+UPPER(m.cDefStruct)+" "$" "+.DataTypes(DATA_INT_STRUCT)+" "
				RETURN .InternalStruct(m.cDefStruct)
			ELSE
				.nError=ERR_INVALID_DEF
				RETURN .F.
			ENDIF
		ENDIF

		.nExMemoWidth=SET("Memowidth")
		SET MEMOWIDTH TO LEN_LINE

*!* caricamento diverso in parte da quello C perch meno complesso sui dati
		cDefStruct=ALLTRIM(m.cDefStruct)

		IF TABU$m.cDefStruct
			cDefStruct=STRTRAN(m.cDefStruct, TABU, " ")
		ENDIF

		PRIVATE i, ii, cRow, cTempStruct, nTempPos1

		LOCAL cRow AS STRING, ;
			cTempStruct AS STRING, ;
			nTempPos1 AS NUMBER

		cTempStruct=LOWER(m.cDefStruct)
		nTempPos1=AT("type ", m.cTempStruct) && end type finale lo verifico dopo

*!* controllo minimo che sia comando VB valido
		IF nTempPos1=0 ;
				OR RAT("endtype", CHRTRAN(LOWER(m.cTempStruct)," ",""))=0 && non definito correttamente

			.nError=ERR_INVALID_DEF
			RETURN .F.
		ENDIF

*!* controllo e nome struttura e conservo anche mantenimento M/m
		m.cDefStruct= SUBSTR(m.cDefStruct, m.nTempPos1)

		.cStructure=CHRTRAN(UPPER(GETWORDNUM(m.cDefStruct,2)),CHR(0)+CRLF,"")

		IF EMPTY(.cStructure)
			.nError=ERR_INVALID_DEF_NAME
			RETURN .F.
		ENDIF

		i=0 && incremento righe array

*!* lavoro di riconoscimento dati
		FOR ii=1 TO MEMLINES(m.cDefStruct)

			cRow=ALLTRIM(MLINE(m.cDefStruct,m.ii))

			nTempPos1=AT("'",m.cRow)
			IF m.nTempPos1>0
				cRow=ALLTRIM(LEFT(m.cRow,m.nTempPos1-1)) && togli commenti
			ENDIF

			IF LOWER(CHRTRAN(m.cRow," ",""))="endtype" && fine
				EXIT
			ENDIF

			IF EMPTY(m.cRow) ;
					OR GETWORDCOUNT(m.cRow)<3 && nome as tipo
				LOOP
			ENDIF

*!* caricamento matrice interna
			i=m.i+1
			IF m.i>1
				DIMENSION M_ARRAY && elemento massimo .aStructMembers[m.i,9]
			ENDIF

			M_IN=NUM_T
			M_OUT=NUM_T
			M_NUM=1
			M_LEN=4

			IF "("$m.cRow && la lunghezza  tra parentesi
				cRow=STRTRAN(m.cRow,"("," (") && stacca parentesi
				M_NUM=INT(VAL(ALLTRIM(STREXTRACT(m.cRow,"(",")"))))
				M_ARRAY=.T. && sar tolta se carattere
			ENDIF

			nTempPos1=AT("*",m.cRow) && la lunghezza  finale
			IF m.nTempPos1>0
				cRow=STRTRAN(m.cRow,"*"," * ") && stacca dal numero
				M_NUM=INT(VAL(GETWORDNUM(m.cRow,GETWORDCOUNT(m.cRow))))
				M_ARRAY=.T. && sar tolta se carattere
				cRow=LEFT(m.cRow,m.nTempPos1-1)
			ENDIF

			IF M_NUM=0
				.ResetClass()
				.nError=ERR_INVALID_ARRAY
				RETURN .F. && passata costante non convertita in numero?
			ENDIF


			M_NAME=GETWORDNUM(m.cRow,1)
			cRow=UPPER(m.cRow)

			nTempPos1=AT(" AS ",m.cRow) && la lunghezza  finale
			IF m.nTempPos1=0
				.ResetClass()
				.nError=ERR_INVALID_DEF
				RETURN .F.
			ENDIF
			cRow=ALLTRIM(SUBSTR(m.cRow,m.nTempPos1+4))

*!* riconoscimento dati

			cTempStruct=GETWORDNUM(m.cRow,1)

			DO CASE
			CASE cTempStruct="BOOLEAN"
				IF !.lBoolNumeric
					M_DATA=BOOL_C
					M_IN=LOGIC_T
					M_OUT=LOGIC_T
				ELSE
					M_DATA=DWORD_C
				ENDIF

			CASE cTempStruct="BYTE"
				M_DATA=TCHAR_C && lo lascio Unsigned
				M_LEN=1
				IF M_ARRAY AND .lAutoArray=.T.
					M_IN=CHAR_T
					M_OUT=CHAR_T
					M_ARRAY=.F.
				ENDIF

			CASE INLIST(m.cTempStruct, "DOUBLE", "SINGLE")
				M_IN=FLOAT_T
				M_OUT=FLOAT_T
				IF m.cTempStruct="DOUBLE"
					M_DATA=DOUBLE_C
					M_LEN=8
				ELSE
					M_DATA=FLOAT_C
				ENDIF

			CASE cTempStruct="INTEGER"
				M_DATA=WORD_C
				M_LEN=2
				IF M_ARRAY AND .lAutoArray=.T.
					M_DATA=WCHAR_C
					M_IN=CHAR_T
					M_OUT=CHAR_T
					M_ARRAY=.F.
				ELSE
					M_SIGNED=.T.
				ENDIF

			CASE cTempStruct="LONG"
				M_DATA=DWORD_C
				M_LEN=4
				M_SIGNED=!M_ARRAY && tipo array di DWORD...

			CASE cTempStruct="STRING"
				M_DATA=TCHAR_C
				M_OUT=CHAR_T
*!*	                M_IN=CHAR_T && "N" come LPTSTR ma vale anche "C"...
				IF M_ARRAY
					M_LEN=1
					M_IN=CHAR_T
					IF .lAutoArray=.T.
*!*	                        M_IN=CHAR_T && ???
						M_ARRAY=.F.
					ELSE
						M_ARRAY=.T.
*!*	                        M_OUT=NUM_T && ???
					ENDIF

				ELSE
					M_MEMORY=.T.
				ENDIF

			OTHERWISE && struttura

				M_IN=STRUCT_T
				M_LEN=0
				IF " "+m.cTempStruct+" "$" "+.DataTypes(DATA_INT_STRUCT)+" "
					M_DATA=INT_STRUCT
					M_OUT=m.cTempStruct
				ELSE
					IF .lUnknownAsStruct=.T.
						M_DATA=EXT_STRUCT
						M_OUT=STRUCT_T
					ELSE
						M_DATA=DWORD_C
						M_LEN=4
						M_SIGNED=.T. && sarebbe come Long
						M_IN=NUM_T
					ENDIF
				ENDIF

			ENDCASE

*!* qui si decide solo il nome: propriet e valori li sistema ResetData()
			IF PEMSTATUS(THIS, M_NAME ,5) ;
					OR (m.i>1 AND ASCAN(.aStructMembers, M_NAME, 1, m.i-1, 1, 15)>0)
				M_NAME="_"+M_NAME
			ENDIF

		NEXT ii

		IF !EMPTY(.aStructMembers[1,1]) && caricato almeno un elemento
			.nElements=ALEN(.aStructMembers,1)
			.ResetData()
		ELSE
			.ResetClass()
			.nError=ERR_NO_MEMBERS
			RETURN .F.
		ENDIF

		SET MEMOWIDTH TO (.nExMemoWidth)
	ENDWITH


	ENDFUNC && fine LoadVBDef

	FUNCTION ResetData
*!* riporta i dati ai volori iniziali

	WITH THIS
		.nError=ERR_NO_ERROR

		IF .nElements=0
			.nError=ERR_DEF_NOT_LOADED
			RETURN .F.
		ENDIF

		PRIVATE i, ii, cProp, cPropInt, cIntStruct, aPropClass

		LOCAL cProp AS STRING, ;
			cIntStruct AS STRING, ;
			cPropInt AS STRING

		LOCAL ARRAY aPropClass[8]

		FOR i=1 TO .nElements
			cProp=M_NAME+IIF(!M_ARRAY, "", "["+LTRIM(STR(M_NUM))+"]")

*!* controllo memoria da liberare
			IF VARTYPE(.aPtrsIn[1])<>"L"
				.ReleasePointers()
				DIMENSION .aPtrsIn[1]
				STORE .F. TO .aPtrsIn
			ENDIF
			IF VARTYPE(.aPtrsOut[1])<>"L"
				DIMENSION .aPtrsOut[1]
				STORE .F. TO .aPtrsOut
			ENDIF

			IF NOT M_IN=STRUCT_T
				.ADDPROPERTY(m.cProp, ;
					IIF(M_IN=CHAR_T, "", ;
					IIF(INLIST(M_IN, NUM_T, FLOAT_T) ;
					OR (M_IN=BIT_T AND (M_DATA<>BOOL_C OR .lBoolNumeric)), 0, ;
					.F.)))
			ELSE

*!*	l'aggiunta come oggetti con AddObject invece che la memorizzazione nella propriet occupa pi memoria
*!*	e credo anche che ci siano dei bug di Fox nel creare arrays di oggetti

				IF !PEMSTATUS(THIS, M_NAME, 5)
					.ADDPROPERTY(m.cProp)
				ENDIF

				aPropClass[1]=.lAllowIntStruct
				aPropClass[2]=.lBoolNumeric
				aPropClass[3]=.lAutoArray
				aPropClass[4]=.lAutoMemory
				aPropClass[5]=.lSplit64bit
				aPropClass[6]=.lUnknownAsStruct
				aPropClass[7]=.lAutoUnicodeConv
				aPropClass[8]=.lAutoFar

				FOR ii=1 TO IIF(!M_ARRAY, 1, M_NUM)

					cProp=M_NAME+IIF(!M_ARRAY, "", ADD_ARRAY)
					cPropInt=DOT+m.cProp

					IF VARTYPE(EVALUATE(m.cPropInt))<>"O"

						STORE CREATEOBJECT(.CLASS) TO (m.cPropInt)

*!* ereditariet
						WITH EVALUATE(m.cPropInt)
							.lAllowIntStruct=aPropClass[1]
							.lBoolNumeric=aPropClass[2]
							.lAutoArray=aPropClass[3]
							.lAutoMemory=aPropClass[4]
							.lSplit64bit=aPropClass[5]
							.lUnknownAsStruct=aPropClass[6]
							.lAutoUnicodeConv=aPropClass[7]
							.lAutoFar=aPropClass[8]
						ENDWITH

						IF .lAllowIntStruct ;
								AND M_DATA=INT_STRUCT
							cIntStruct=M_OUT
							WITH EVALUATE(m.cPropInt)
								IF INLIST(m.cIntStruct, LI_S, ULI_S)
									.cStructure=NULL && utilizzo un piccolo trucco per caricarli come interne
								ENDIF
								.LoadCDef(m.cIntStruct)
							ENDWITH
						ENDIF
					ELSE

						WITH EVALUATE(m.cPropInt)
							.ResetData()
						ENDWITH
					ENDIF
				NEXT ii

			ENDIF
		NEXT i

	ENDWITH

	ENDFUNC && fine ResetData

	FUNCTION CalculateBytes
*!* calcola il totale dei bytes della struttura
	PRIVATE i, ii, nBytes, cProp, nBytesInt, cExFixed, lBits, ;
		cExcluded, lNotExcluded, n8Bits, nLastElem, nMaxB
	LOCAL nBytes AS NUMBER, ;
		cProp AS OBJECT, ;
		nBytesInt AS NUMBER, ;
		cExFixed AS STRING, ;
		lBits AS Logical, ;
		cExcluded AS STRING, ;
		lNotExcluded AS Logical, ;
		n8Bits AS NUMBER, ;
		nLastElem AS NUMBER, ;
		nMaxB AS NUMBER

	nBytes=0
	cProp=""

	WITH THIS

		.nError=ERR_NO_ERROR

		IF .nElements=0
			.nError=ERR_DEF_NOT_LOADED
			RETURN 0
		ENDIF

		IF ASCAN(.aStructMembers, BIT_T, 1, .nElements, 6, 6)>0 && tento di fare operazioni solo se necessario
			lBits=.T.
			n8Bits=0
			cExFixed=SET("Fixed")
			SET FIXED OFF && per i valori corretti nei membri in bit
		ENDIF

		lNotExcluded=(EMPTY(.cExcludeList))
		cExcluded=IIF(m.lNotExcluded, "", LOWER(SEMICOLON+.cExcludeList+SEMICOLON))

		nLastElem=LAST_ELEMENT

		FOR i=1 TO m.nLastElem && .nElements
*!*	pi rapida la verifica
			IF !m.lNotExcluded ;
					AND SEMICOLON+LOWER(M_NAME)+SEMICOLON$m.cExcluded
				LOOP
			ENDIF

			FOR ii=1 TO M_NUM
				DO CASE
				CASE !INLIST(M_IN, STRUCT_T, BIT_T)
					nBytes=nBytes+M_LEN
				CASE M_IN=STRUCT_T
					cProp=EVALUATE(DOT+M_NAME+IIF(!M_ARRAY,"",ADD_ARRAY))

					IF VARTYPE(m.cProp)<>"O"
						.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
						RETURN 0
					ENDIF

					WITH (m.cProp)
						IF PEMSTATUS(m.cProp, "CalculateBytes", 5) && non verifico se  anche Method
							nBytesInt=.CalculateBytes()
						ELSE
							nBytesInt=0 && come vuoto
						ENDIF
					ENDWITH

					IF m.nBytesInt=0 && struttura interna non caricata
						.nError=ERR_2_LEVEL_STRUCT
.nItemInError = m.i
						RETURN 0
					ENDIF

					nBytes=nBytes+m.nBytesInt
					IF M_LEN<>m.nBytesInt && assegna il valore alla struttura principale
						M_LEN=m.nBytesInt
					ENDIF
				CASE M_IN=BIT_T
					nBytes=m.nBytes+M_LEN
					nMaxB=M_LEN
					DO WHILE .T.
						n8Bits=m.n8Bits+VAL(M_OUT)*BIT_PART
						IF m.n8Bits>m.nMaxB
							n8Bits= m.nMaxB-m.n8Bits
							nBytes=m.nBytes+M_LEN
						ENDIF

						i=m.i+1
						IF m.i>m.nLastElem OR M_IN<>BIT_T
							i=m.i-1
							n8Bits=0
							EXIT
						ENDIF
					ENDDO

				ENDCASE
			NEXT ii
		NEXT i

		cProp=.NULL.

		IF m.lBits
			SET FIXED &cExFixed
*!*			nBytes=Ceiling(m.nBytes) && supporto per membri in bit che arrotonda al byte
		ENDIF

*!*	Aggiustamento strutture
		nBytesInt=.nPadding
		IF .nPadding=PADDING_AUTO
			m.nBytesInt=MOD(m.nBytes, 4)
			IF m.nBytesInt>0
				nBytesInt= 4 - m.nBytesInt
			ENDIF
		ENDIF

		RETURN m.nBytes+m.nBytesInt

	ENDWITH

	ENDFUNC && fine CalculateBytes

	FUNCTION MakeStruct
*!* restituisce la stringa della struttura da passare alla funzione API
	LPARAMETERS lAllZero, nLength

	WITH THIS
		.nError=ERR_NO_ERROR

		IF PCOUNT()>0
			IF VARTYPE(m.lAllZero)<>"L"
				.nError=ERR_BAD_PARAMS
				RETURN ""
			ENDIF
			IF PCOUNT()>1 AND VARTYPE(m.nLength)<>"N"
				.nError=ERR_BAD_PARAMS
				RETURN ""
			ENDIF
		ENDIF

		IF EMPTY(m.nLength) OR m.nLength<1
			nLength=0
		ENDIF

		PRIVATE i, ii, cCharString, cRetVal, eValue, cProp, nBytes, ;
			nBits, cValType, nBytesTot, nLastElem, cExcluded, lNotExcluded
		LOCAL cCharString AS STRING, ;
			cRetVal AS STRING, ;
			eValue AS Variant, ;
			cProp AS STRING, ;
			nBytes AS NUMBER, ;
			nBits AS NUMBER, ;
			cValType AS STRING, ;
			nBytesTot AS NUMBER, ;
			nLastElem AS NUMBER, ;
			cExcluded AS STRING, ;
			lNotExcluded AS Logical

		nBytesTot=.CalculateBytes()

		IF m.nLength=0 OR !m.lAllZero
			IF .nElements=0
				.nError=ERR_DEF_NOT_LOADED
				RETURN ""
			ENDIF

			IF m.nBytesTot=0
				.nError=ERR_2_LEVEL_STRUCT

.nItemInError = m.i
				RETURN ""
			ENDIF
		ENDIF

		IF m.lAllZero
			.nError=ERR_NO_ERROR
			RETURN REPLICATE(CHR(0), MAX(m.nBytesTot, m.nLength))
		ENDIF

		IF VARTYPE(.aPtrsIn[1])<>"L"
			.ReleasePointers() && li pulisco qui ma la matrice la dimensiono dopo
			STORE "" TO .aPtrsIn
		ENDIF

		.lMakeIsLast=.T.
		cRetVal=""
		lNotExcluded=(EMPTY(.cExcludeList))
		cExcluded=IIF(m.lNotExcluded, "", LOWER(SEMICOLON+.cExcludeList+SEMICOLON))
		nLastElem=LAST_ELEMENT

		FOR i=1 TO m.nLastElem && .nElements
*!*	pi rapida la verifica
			IF !m.lNotExcluded ;
					AND SEMICOLON+LOWER(M_NAME)+SEMICOLON$m.cExcluded
				LOOP
			ENDIF

			FOR ii=1 TO IIF(M_IN=CHAR_T, 1, M_NUM)
				eValue=EVALUATE(DOT+M_NAME+IIF(!M_ARRAY,"",ADD_ARRAY))

*!*	aggiunto supporto ad eccezione sub-strutture e bit gestiti a parte
				IF ISNULL(m.eValue)
					eValue=IIF(M_IN=CHAR_T, "", IIF(M_IN=LOGIC_T, .F., 0))
				ENDIF

				cValType=VARTYPE(m.eValue)

				DO CASE
				CASE M_IN=NUM_T && input numerico
					IF m.cValType<>"N"
						IF !M_MEMORY
							.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
							RETURN ""
						ELSE
							IF m.cValType="C"
								IF .lAutoMemory=.T.
									cCharString=m.eValue+CHR(0)+CHR(0) && uno di fine stringa e uno fine dati
									IF M_DATA= WCHAR_C
										cCharString=IIF(.lAutoUnicodeConv, STRCONV(m.cCharString, 12), m.cCharString+U_END)
									ENDIF

*!*	conservo il testo e memorizzo il pointer nell'array creata solo ad esigenza
*!*	occorre prevedere anche il raro caso di array di puntatori
									IF VARTYPE(.aPtrsIn[1])="L"
										DIMENSION .aPtrsIn[.nElements] && viene dimensionata solo se occorre
										STORE "" TO .aPtrsIn
									ENDIF

									eValue=.WriteMemory(m.cCharString)
									M_POINTER_IN= M_POINTER_IN+IIF(m.ii=1, "", ;
										" "+REPLICATE("0 ", m.ii-GETWORDCOUNT(M_POINTER_IN)-1) ) + ;
										LTRIM(STR(m.eValue))

								ELSE
									.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
									RETURN ""
								ENDIF
							ELSE
								eValue=0
							ENDIF
						ENDIF
					ENDIF
					cCharString=.Num2Char(m.eValue, M_LEN)
				CASE M_IN=CHAR_T && input carattere
					IF m.cValType<>"C"
*!*							If !M_MEMORY
						.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
						RETURN ""
*!*							Else
*!*								eValue=""
*!*							Endif
					ENDIF
					IF M_DATA<>WCHAR_C OR .lAutoUnicodeConv
						cCharString=PADR(m.eValue, M_NUM, A_END)
						IF M_DATA=WCHAR_C
							cCharString=STRCONV(m.cCharString, 12)
						ENDIF
					ELSE
						cCharString=PADR(m.eValue, M_NUM*2, A_END)
					ENDIF
				CASE M_IN=LOGIC_T && input logico
					IF m.cValType<>"L"
						.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
						RETURN ""
					ENDIF
					eValue=IIF(m.eValue=.T.,1,0)
					cCharString=.Num2Char(m.eValue,M_LEN)

				CASE M_IN=STRUCT_T && struttura o dato non riconosciuto
					IF m.cValType<>"O" && qualcosa non ha funzionato
						.nError=ERR_2_LEVEL_STRUCT
.nItemInError = m.i
						RETURN ""
					ENDIF

					WITH m.eValue
						cCharString=.MakeStruct()
						IF LEN(m.cCharString)=0
							.nError=ERR_2_LEVEL_STRUCT
.nItemInError = m.i
							RETURN ""
						ENDIF
					ENDWITH

				CASE M_IN=FLOAT_T
					IF m.cValType<>"N"
						.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
						RETURN ""
					ENDIF
					cCharString=.Float2Char(m.eValue,IIF(M_DATA=FLOAT_C,.F.,.T.))

				CASE M_IN=BIT_T

					nBytes = M_LEN*N_BIT
					cProp=""

					DO WHILE .T.

						cValType=VARTYPE(m.eValue)

						IF m.cValType<>"N"
							DO CASE
							CASE m.cValType="L"
								eValue=IIF(m.eValue, 1, 0)
							CASE m.cValType="X" && Null
								eValue=0
							OTHERWISE
								.nError=ERR_INVALID_DATA_IN
.nItemInError = m.i
								RETURN .F.
							ENDCASE
						ENDIF

						nBits=VAL(M_OUT)

						nBytes=m.nBytes-m.nBits

						IF m.nBytes<0 && sarebbe un nuovo elemento per cui riparto
							i=m.i-1
							eValue=0
							EXIT
						ENDIF


						cProp=IIF(m.nBits=1, IIF(m.eValue=0, "0", "1"), ;
							PADL(.Num2Bin(m.eValue), m.nBits, "0"))+m.cProp

						IF m.nBytes<1
							EXIT
						ENDIF

						i=m.i+1
						IF m.i>m.nLastElem OR M_IN<>BIT_T
							i=m.i-1
							EXIT
						ENDIF

						eValue=EVALUATE(DOT+M_NAME)
					ENDDO

					cCharString= .Num2Char(.Bin2Num(m.cProp), M_LEN) && -Int(m.nBytes/N_BIT))

				ENDCASE

				cRetVal=m.cRetVal+m.cCharString
			NEXT ii
		NEXT i

		RETURN IIF(m.nLength=0 AND .nPadding=PADDING_NONE, m.cRetVal, PADR(m.cRetVal, MAX(m.nBytesTot, m.nLength), CHR(0)))

	ENDWITH
	ENDFUNC && fine MakeStruct

	FUNCTION SplitStruct
*!* riporta nei membri della classe i valori convertiti della stringa struttura restituita
	LPARAMETERS cCharString

	WITH THIS
		.nError=ERR_NO_ERROR

		IF VARTYPE(m.cCharString)<>"C"
			.nError=ERR_BAD_PARAMS
			RETURN .F.
		ENDIF

		PRIVATE i, ii, cProp, nStartPos, cPortion, lUnicode, ;
			nAddrInt, aAddrMem, cPropName, nAddr, nElem, nBytes, ;
			c2EndList, l2Ending, nLastElem, cExcluded, lNotExcluded
		LOCAL cProp AS STRING, ;
			nStartPos AS NUMBER, ;
			cPortion AS STRING, ;
			lUnicode AS Logical, ;
			nAddr AS NUMBER, ;
			nAddrInt AS NUMBER, ;
			cPropName AS STRING, ;
			nBytes AS NUMBER, ;
			c2EndList AS STRING, ;
			l2Ending AS Logical, ;
			nLastElem AS NUMBER, ;
			cExcluded AS STRING, ;
			lNotExcluded AS Logical

		LOCAL ARRAY aAddrMem[1]

		m.nStartPos=1

		IF .nElements=0
			.nError=ERR_DEF_NOT_LOADED
			RETURN .F.
		ENDIF

		nBytes=.CalculateBytes()

		IF m.nBytes=0
			.nError=ERR_2_LEVEL_STRUCT
.nItemInError = m.i
			RETURN .F.
		ENDIF

		IF VARTYPE(.aPtrsOut[1])<>"L"
			STORE "" TO .aPtrsOut && qui non si libera memoria
		ENDIF
		.lMakeIsLast=.F.
		c2EndList=IIF(EMPTY(.cDoubleNullList), "", LOWER(SEMICOLON+.cDoubleNullList+SEMICOLON))
		lNotExcluded=(EMPTY(.cExcludeList))
		cExcluded=IIF(m.lNotExcluded, "", LOWER(SEMICOLON+.cExcludeList+SEMICOLON))
		nLastElem=LAST_ELEMENT

		FOR i=1 TO m.nLastElem && .nElements
*!*	pi rapida la verifica
			IF !m.lNotExcluded ;
					AND SEMICOLON+LOWER(M_NAME)+SEMICOLON$m.cExcluded
				LOOP
			ENDIF

			FOR ii=1 TO IIF(!M_ARRAY, 1, M_NUM)
				cProp=DOT+M_NAME+IIF(!M_ARRAY, "", ADD_ARRAY)
				cPortion=SUBSTR(m.cCharString, m.nStartPos, M_LEN*IIF(!M_ARRAY, M_NUM, 1))
				lUnicode=.F.

				DO CASE
				CASE M_OUT==NUM_T
					IF M_DATA<>CHARFAR_C
						STORE .Char2Num(m.cPortion, M_SIGNED) TO (m.cProp)
					ELSE

						STORE "" TO (m.cProp)

						aAddrMem[1]=0
						cPropName=DOT+M_NAME

						nAddr=.Char2Num(m.cPortion)

						IF m.nAddr>0
							DO WHILE .T.

								nAddrInt=.Char2Num(.ReadMemory(m.nAddr,4))

								IF m.nAddrInt=0
									EXIT
								ENDIF

								nElem=ALEN(aAddrMem)

								IF m.nElem=1 AND EMPTY(aAddrMem[1])
									aAddrMem[1]=m.nAddrInt
								ELSE
									DIMENSION aAddrMem[m.nElem+1]
									aAddrMem[m.nElem+1]=m.nAddrInt
								ENDIF

								nAddr=m.nAddr+4
							ENDDO
							=ACOPY(aAddrMem, &cPropName)
						ENDIF && m.nAddr>0
						cPropName=.NULL.
					ENDIF && M_DATA<>CHARFAR_C

				CASE M_OUT==CHAR_T

					IF M_DATA=WCHAR_C
						IF !M_MEMORY
							cPortion=STRCONV(m.cPortion, 10)
						ELSE
							lUnicode=.T.
						ENDIF

					ENDIF

					IF M_MEMORY
						nAddr=.Char2Num(m.cPortion)
						IF .lAutoMemory=.T.
							m.l2Ending=(!EMPTY(m.c2EndList) AND SEMICOLON+LOWER(M_NAME)+SEMICOLON$m.c2EndList)
							cPortion=.ReadMemory(m.nAddr,, m.lUnicode, m.l2Ending)

							IF VARTYPE(.aPtrsOut[1])="L"
								DIMENSION .aPtrsOut[.nElements]
								STORE "" TO .aPtrsOut
							ENDIF

							M_POINTER_OUT=M_POINTER_OUT+IIF(m.ii=1, "", ;
								" "+REPLICATE("0 ", m.ii-GETWORDCOUNT(M_POINTER_OUT)-1) ) + ;
								+LTRIM(STR(m.nAddr))

						ELSE
							cPortion=m.nAddr
						ENDIF
					ELSE

						nAddr=AT(A_END, m.cPortion)
						IF m.nAddr>0 AND M_DATA<>BYTE_C
							cPortion=LEFT(m.cPortion, m.nAddr-1) && unico modo per preservare tutti i caratteri, ma solo strutture C
							IF M_DATA=WCHAR_C AND !.lAutoUnicodeConv
								cPortion=STRCONV(m.cPortion,12) && lo riconverti
							ENDIF
						ENDIF

					ENDIF

					STORE m.cPortion TO (m.cProp)

				CASE M_OUT==STRUCT_T OR M_DATA=INT_STRUCT

					WITH EVALUATE(m.cProp)
						lResult=.SplitStruct(m.cPortion)
					ENDWITH

					IF !m.lResult
						.nError=ERR_2_LEVEL_STRUCT
.nItemInError = m.i
						RETURN .F.
					ENDIF

				CASE M_OUT==LOGIC_T
					STORE (.Char2Num(m.cPortion)<>0) TO (m.cProp)

				CASE M_OUT==FLOAT_T
					STORE .Char2Float(m.cPortion) TO (m.cProp)

				CASE M_IN==BIT_T
					cPortion=PADL(.Num2Bin(.Char2Num(m.cPortion)), M_LEN*N_BIT,"0")

					DO WHILE .T.

						nElem=VAL(M_OUT) && riciclo variabili
						cPropName=RIGHT(m.cPortion, m.nElem)

						nAddr=IIF(m.nElem=1, INT(VAL(m.cPropName)), .Bin2Num(m.cPropName))
						IF M_DATA=BOOL_C AND !.lBoolNumeric
							nAddr= (m.nAddr<>0)
						ENDIF

						STORE m.nAddr TO (DOT+M_NAME) && m.cProp  rimasto il primo

						IF m.nElem>LEN(m.cPortion) && esco in caso di nuovo elemento
							i=m.i-1
							cPortion=""
							EXIT
						ENDIF

						cPortion=LEFT(m.cPortion, LEN(m.cPortion)-m.nElem)
						IF EMPTY(m.cPortion)
							EXIT
						ENDIF

						i=m.i+1
						IF m.i>m.nLastElem OR M_IN<>BIT_T
							i=m.i-1 && ritorno all'ultimo anche per evitare errore finale
							cPortion="" && qui sta un dubbio se non  finito il numero di bit
							EXIT
						ENDIF

					ENDDO

				ENDCASE

				nStartPos=m.nStartPos+M_LEN*IIF(!M_ARRAY, M_NUM, 1)
			NEXT ii
		NEXT i

		cProp=.NULL.
	ENDWITH

	ENDFUNC && fine SplitStruct

	FUNCTION Char2Num
*!* da stringa caratteri al valore numerico tipo dword
	LPARAMETERS cCharInt, lSigned

	IF VARTYPE(m.cCharInt)<>"C" ;
			OR LEN(m.cCharInt)=0 ;
			OR VARTYPE(m.lSigned)<>"L"
		THIS.nError=ERR_BAD_PARAMS
		RETURN 0
	ENDIF

	THIS.nError=ERR_NO_ERROR

	PRIVATE i, nRetVal, nLenChar
	LOCAL nRetVal AS NUMBER, ;
		nLenChar AS NUMBER

	nRetVal=0
	nLenChar=LEN(m.cCharInt)

	FOR i=1 TO m.nLenChar
		nRetVal=m.nRetVal+(ASC(SUBSTR(m.cCharInt,m.i,1))*(256^(m.i-1)))
	NEXT

	IF m.lSigned ;
			AND m.nRetVal>EVALUATE("0x7F"+REPLICATE("FF",m.nLenChar-1))
		nRetVal=m.nRetVal -1 -EVALUATE("0x"+REPLICATE("FF",m.nLenChar))
	ENDIF

	RETURN INT(m.nRetVal)
	ENDFUNC && fine Char2Num

	FUNCTION Num2Char
*!* stringa caratteri tipo dword da espressione numerica con pad lunghezza
	LPARAMETERS nIntValue, nChar
	IF PCOUNT()<1 ;
			OR VARTYPE(m.nIntValue)<>"N" ;
			OR (!EMPTY(m.nChar) AND VARTYPE(m.nChar)<>"N")
		THIS.nError=ERR_BAD_PARAMS
		RETURN ""
	ENDIF

	IF EMPTY(m.nChar)
		nChar=4
	ENDIF

	THIS.nError=ERR_NO_ERROR

	PRIVATE i, nOper, cRetVal
	LOCAL nOper AS NUMBER, ;
		cRetVal AS STRING

	nIntValue=INT(m.nIntValue)

*!* il numero negativo pu essere passato solo per risultati Signed tipo SHORT, INT, LONG ...
	IF SIGN(m.nIntValue)=-1
		nIntValue=m.nIntValue+1+EVALUATE("0x"+REPLICATE("FF", m.nChar))
	ENDIF

	nOper=0
	cRetVal=""
	i=0

	DO WHILE m.nIntValue>0
		nOper=MOD(INT(m.nIntValue/256^m.i), 256)
		cRetVal=m.cRetVal+CHR(m.nOper)
		nIntValue=m.nIntValue-(m.nOper*(256^m.i))
		i=m.i+1
	ENDDO

	RETURN PADR(m.cRetVal,m.nChar,CHR(0))

	ENDFUNC && fine Num2Char

	FUNCTION ReadMemory
*!* funzione di lettura per i pointers nella memoria
	LPARAMETERS nMemAddr, nSizeRead, lUnicode, lDoubleNull

	WITH THIS
		.nError=ERR_NO_ERROR
*!* qui verifico i parametri
		IF PCOUNT()<1 ;
				OR VARTYPE(m.nMemAddr)<>"N" OR m.nMemAddr=0 OR SIGN(m.nMemAddr)=-1 ;
				OR (VARTYPE(m.nSizeRead)<>"N" AND !EMPTY(m.nSizeRead)) ;
				OR VARTYPE(m.lUnicode)<>"L"
			.nError=ERR_BAD_PARAMS
			RETURN ""
		ENDIF

		IF VARTYPE(m.lDoubleNull)<>"L"
			lDoubleNull=.F. && perdono errore
		ENDIF

		PRIVATE cMemoryStr, cTempRes, nCharTrim, nLockMem, cCharEnd
		LOCAL cMemoryStr AS STRING, ;
			cTempRes AS STRING, ;
			nCharTrim AS NUMBER, ;
			nLockMem AS NUMBER, ;
			cCharEnd AS STRING

		DECLARE INTEGER GlobalLock IN win32api AS _rps_GlobalLock ;
			INTEGER HMEM

*!*	cerco di evitare che questa funzione sovrascriva indirizzo
		nLockMem=_rps_GlobalLock(m.nMemAddr)

		cTempRes=""
		cMemoryStr=""

		IF VARTYPE(m.nSizeRead)="N" AND !BETWEEN(m.nSizeRead, 0, MAX_CHAR_VAR_TOT)
			nSizeRead=IIF(m.nSizeRead<0, 0, MAX_CHAR_VAR_TOT)
		ENDIF

		IF !EMPTY(m.nSizeRead)

			IF .ExtractMemString(@cMemoryStr, m.nMemAddr, m.nSizeRead)

				cTempRes=m.cMemoryStr
			ENDIF
		ELSE
			nSizeRead=.GetMemorySize(m.nMemAddr)

			IF !BETWEEN(m.nSizeRead, 0, MAX_CHAR_VAR)
				nSizeRead=0
			ENDIF

			nCharTrim=IIF(!m.lDoubleNull, 1, 2)
			cCharEnd=IIF(!m.lDoubleNull, A_END, U_END)

			IF m.nSizeRead>0
				IF .ExtractMemString(@cMemoryStr, m.nMemAddr, m.nSizeRead)

*!* controllo che all'interno ci sia il carattere di termine, se non c' rimando alla funzione sotto
					IF m.lUnicode
						cMemoryStr=STRCONV(m.cMemoryStr, 10)
					ENDIF

					IF m.cCharEnd$m.cMemoryStr

*!* ma pu essere pi lungo quindi taglio al primo carattere non Null
						cTempRes=STREXTRACT(m.cMemoryStr, "", m.cCharEnd)
					ENDIF
				ENDIF
			ENDIF

			IF EMPTY(m.cTempRes) && ultimo tentativo: funziona con i CHAR FAR * ... GlobalSize no!
				nSizeRead= MEMORY_SEGMENT
				cTempRes=""

				DO WHILE .T.
					cMemoryStr=""
					IF !.ExtractMemString(@cMemoryStr, m.nMemAddr, m.nSizeRead)
						EXIT
					ENDIF

					IF m.lUnicode && rallenta forse ma  metodo sicuro per avere il vero carattere null finale
						cMemoryStr=STRCONV(m.cMemoryStr, 10)
					ENDIF

					IF m.cCharEnd$m.cMemoryStr
						cMemoryStr=STREXTRACT(m.cMemoryStr, "", m.cCharEnd)
						cTempRes=m.cTempRes+m.cMemoryStr
						EXIT

					ELSE
						cTempRes=m.cTempRes+m.cMemoryStr

*!*	assurdo che capiti ma non corro il rischio
						IF LEN(m.cTempRes)>=MAX_CHAR_VAR
							EXIT
						ENDIF
						nMemAddr=m.nMemAddr+MEMORY_SEGMENT
					ENDIF
				ENDDO
			ENDIF

			IF m.lUnicode AND !.lAutoUnicodeConv
				cTempRes=STRCONV(m.cTempRes, 12)
			ENDIF

		ENDIF

*!* vediamo poi se metterlo opzionale
		IF m.nLockMem>0
			DECLARE INTEGER GlobalUnlock IN win32api AS _rps_GlobalUnlock ;
				INTEGER HMEM

			=_rps_GlobalUnlock(m.nMemAddr)
		ENDIF

		RETURN m.cTempRes
	ENDWITH

	ENDFUNC && fine ReadMemory

	FUNCTION Float2Char
*!* da un numero con virgola ritorna la stringa carattere
	LPARAMETERS nFloat, lDouble

	WITH THIS
		IF PCOUNT()<1 ;
				OR VARTYPE(m.nFloat)<>"N" ;
				OR VARTYPE(m.lDouble)<>"L"
			.nError=ERR_BAD_PARAMS
			RETURN ""
		ENDIF

		.nError=ERR_NO_ERROR

		#IF VERSION(5)<900
			PRIVATE i, cBinStr, nLExp, nLMant, ;
				nBias, nMant, cSign, nExDecim, ;
				nDecim, cRetVal

			LOCAL cBinStr AS STRING, ;
				nLExp AS NUMBER, ;
				nLMant AS NUMBER, ;
				nBias AS NUMBER, ;
				nExp AS NUMBER, ;
				nMant AS NUMBER, ;
				cSign AS NUMBER, ;
				cRetVal AS STRING, ;
				nExDecim AS NUMBER, ;
				nDecim AS NUMBER

			nLExp=IIF(m.lDouble,DBL_L_EXP,FTL_L_EXP)
			nLMant=IIF(m.lDouble,DBL_L_MANT,FTL_L_MANT)
			nBias=IIF(m.lDouble,DBL_BIAS_EXP,FTL_BIAS_EXP)
			nDecim=IIF(m.lDouble,DBL_DECIM,FLT_DECIM)
			cSign=IIF(SIGN(m.nFloat)=1,"0","1")
			nFloat=ABS(m.nFloat)
			nExDecim=SET("Decimals")
			IF m.nExDecim<>15
				SET DECIMALS TO 15
			ENDIF

			IF m.nFloat>0
				i=1
				DO CASE
				CASE m.nFloat>2
					DO WHILE m.nFloat/2^m.i>2
						i=m.i+1
					ENDDO
				CASE m.nFloat<1
					DO WHILE m.nFloat/2^-m.i<2
						i=m.i+1
					ENDDO
					i=(m.i-1)*-1
				CASE BETWEEN(m.nFloat,1,2)
					i=IIF(m.nFloat<>2,0,1)
				ENDCASE

				nExp=m.i+m.nBias
				nMant=m.nFloat/2^m.i

				nMant=ROUND((m.nMant-INT(m.nMant))*2^m.nLMant, 0)

				cBinStr=m.cSign+ ;
					PADL(.Num2Bin(m.nExp),m.nLExp,"0")+ ;
					PADL(.Num2Bin(m.nMant),m.nLMant,"0")

				m.cRetVal=""
				FOR i=1 TO LEN(m.cBinStr) STEP 8
					cRetVal=m.cRetVal+ ;
						CHR(.Bin2Num(SUBSTR(m.cBinStr,m.i,8)))
				NEXT

			ELSE
				cRetVal=REPLICATE(CHR(0),IIF(m.lDouble,8,4))
			ENDIF

			IF SET("Decimals")<> m.nExDecim
				SET DECIMALS TO m.nExDecim
			ENDIF

			RETURN m.cRetVal
		#ELSE
			RETURN BINTOC(m.nFloat, IIF(m.lDouble, "B", "F")+"R")
		#ENDIF

	ENDWITH
	ENDFUNC && fine Float2Char

	FUNCTION Char2Float
*!* dalla stringa carattere ritorna un numero con virgola
	LPARAMETERS cCharFloat

	IF VARTYPE(m.cCharFloat)<>"C" ;
			OR !INLIST(LEN(m.cCharFloat),4,8)
		THIS.nError=ERR_BAD_PARAMS
		RETURN 0
	ENDIF

	THIS.nError=ERR_NO_ERROR

	#IF VERSION(5)<900

		PRIVATE i, lDouble, cBinStr, nLExp, nLMant, ;
			nBias, nMant, nSign, nExDecim, nRetVal

		LOCAL lDouble AS Logical, ;
			cBinStr AS STRING, ;
			nLExp AS NUMBER, ;
			nLMant AS NUMBER, ;
			nBias AS NUMBER, ;
			nExp AS NUMBER, ;
			nMant AS NUMBER, ;
			nSign AS NUMBER, ;
			nRetVal AS NUMBER, ;
			nExDecim AS STRING

		lDouble=IIF(LEN(m.cCharFloat)=4,.F.,.T.)
		nLExp=IIF(m.lDouble,DBL_L_EXP,FTL_L_EXP)
		nLMant=IIF(m.lDouble,DBL_L_MANT,FTL_L_MANT)
		nBias=IIF(m.lDouble,DBL_BIAS_EXP,FTL_BIAS_EXP)
		nExDecim=SET("Decimals")
		IF m.nExDecim<>15
			SET DECIMALS TO 15
		ENDIF

		WITH THIS

			IF NOT m.cCharFloat==REPLICATE(CHR(0),IIF(m.lDouble,8,4))
				cBinStr=""
				FOR i=1 TO IIF(m.lDouble,8,4)
					cBinStr=m.cBinStr+PADL(.Num2Bin(ASC(SUBSTR(m.cCharFloat,m.i,1))),8,"0")
				NEXT

				nSign=IIF(LEFT(m.cBinStr,1)="0",+1,-1)
				nExp=.Bin2Num(SUBSTR(m.cBinStr,2,m.nLExp))-m.nBias
				nMant=1+ .Bin2Num(RIGHT(m.cBinStr,m.nLMant))/2^m.nLMant
				nRetVal= m.nMant*2^m.nExp*m.nSign

				IF !m.lDouble
					nRetVal=ROUND(m.nRetVal,FLT_DECIM)
				ENDIF
			ELSE
				nRetVal=0
			ENDIF

			IF SET("Decimals")<> m.nExDecim
				SET DECIMALS TO m.nExDecim
			ENDIF

		ENDWITH

		RETURN m.nRetVal

	#ELSE
		RETURN ROUND(CTOBIN(m.cCharFloat, "NR"), IIF(LEN(m.cCharFloat)=8, DBL_DECIM, FLT_DECIM))

	#ENDIF

	ENDFUNC && fine Char2Float

	PROTECTED FUNCTION Num2Bin(nVal)
*!* stringa binaria (carattere) da numero

		IF VARTYPE(m.nVal)<>"N"
			RETURN ""
		ENDIF
		IF m.nVal<1 && non supporto per ora i negativi
			RETURN "0"
		ENDIF

		PRIVATE i, nOper, cRetVal
		LOCAL nOper AS NUMBER, ;
			cRetVal AS STRING
		nOper=0
		cRetVal=""

		i=0
		DO WHILE m.nVal>0
			nOper=MOD(INT(m.nVal/2^m.i),2)
			cRetVal=IIF(m.nOper=0,"0","1")+m.cRetVal
			nVal=m.nVal-m.nOper*(2^m.i)
			i=m.i+1
		ENDDO

		RETURN m.cRetVal

		ENDFUNC && Num2Bin


	PROTECTED FUNCTION Bin2Num(cBin)
*!* numero da stringa binaria carattere

		IF VARTYPE(m.cBin)<>"C" OR EMPTY(m.cBin)
			RETURN 0
		ENDIF

		PRIVATE i, m.nEsp, nRetVal
		LOCAL nEsp AS NUMBER, ;
			nRetVal AS NUMBER
		nEsp=0
		nRetVal=0

		FOR i=LEN(m.cBin) TO 1 STEP -1
			IF SUBSTR(m.cBin,m.i,1)="1"
				nRetVal=m.nRetVal+ 2^m.nEsp
			ENDIF
			nEsp=m.nEsp+1
		NEXT

		RETURN INT(m.nRetVal)

		ENDFUNC && fine Bin2Num

	FUNCTION ResetClass
*!* resetta la classe alla condizione iniziale prima di caricare una struttura
	WITH THIS
		.nError=ERR_NO_ERROR

		#IF VERSION(5)>=800 && solo da VFP8
			IF VARTYPE(.aPtrsIn[1])<>"L"
				.ReleasePointers()
				DIMENSION .aPtrsIn[1]
				STORE .F. TO .aPtrsIn
			ENDIF
			IF VARTYPE(.aPtrsOut[1])<>"L"
				DIMENSION .aPtrsOut[1]
				STORE .F. TO .aPtrsOut
			ENDIF

			PRIVATE i
			FOR i=1 TO .nElements && rimuovo la propriet
				=REMOVEPROPERTY(THIS, M_NAME)
			NEXT
		#ELSE
			.ResetData() && in VFP7 non vengono rimosse le propriet quindi neanche il Destroy delle sub-strutture
		#ENDIF

		DIMENSION .aStructMembers[1,9]
		STORE .F. TO .aStructMembers

		.nElements=0
		.cStructure=""
		.lMakeIsLast=.F.

		SET MEMOWIDTH TO (.nExMemoWidth)
	ENDWITH

	ENDFUNC && fine ResetClass

	FUNCTION ClipMembers
*!* per i programmatori: copia i membri della struttura negli appunti per inserirli in With ... EndWith
	LPARAMETERS nMode

	IF PCOUNT()<1 OR VARTYPE(m.nMode)<>"N" ;
			OR !BETWEEN(m.nMode, CLIP_NORMAL, CLIP_FORCE_AND_INFO)
		nMode=CLIP_NORMAL
	ENDIF
	nMode=INT(m.nMode)

	WITH THIS
		.nError=ERR_NO_ERROR

		IF .nElements=0
			.nError=ERR_DEF_NOT_LOADED
			RETURN .F.
		ENDIF

		PRIVATE i, ii, cClipString, cPortion, cProp, lSuccess, cExClip, ;
			cExcluded, lNotExcluded
		LOCAL cClipString AS STRING, ;
			cPortion AS STRING, ;
			cProp AS OBJECT, ;
			lSuccess AS Logical, ;
			cExClip AS STRING, ;
			cExcluded AS STRING, ;
			lNotExcluded AS Logical

		cClipString=""
		cPortion=""
		cExClip=_CLIPTEXT
		lNotExcluded=(EMPTY(.cExcludeList))
		cExcluded=IIF(m.lNotExcluded, "", LOWER(SEMICOLON+.cExcludeList+SEMICOLON))

		FOR i=1 TO LAST_ELEMENT && .nElements
*!*	pi rapida la verifica
			IF !m.lNotExcluded ;
					AND SEMICOLON+LOWER(M_NAME)+SEMICOLON$m.cExcluded
				LOOP
			ENDIF

			FOR ii=1 TO IIF(!M_ARRAY, 1, M_NUM)
				cProp=DOT+M_NAME+IIF(!M_ARRAY, "", ADD_ARRAY)
				IF M_IN<>STRUCT_T
					cPortion=m.cProp
					IF INLIST(m.nMode, CLIP_INFO, CLIP_FORCE_AND_INFO)

						cPortion=m.cPortion+ CMT_FLAG
						DO CASE
						CASE M_IN=NUM_T
							IF !M_MEMORY
								cPortion=m.cPortion+CMT_NUMERIC+CMT_COMMA+IIF(M_SIGNED, CMT_SIGNED, CMT_UNSIGNED)
							ELSE
								IF M_DATA<>CHARFAR_C OR (M_DATA=CHARFAR_C AND !M_ARRAY)
									cPortion=m.cPortion+CMT_INPUT+CMT_NUMERIC+IIF(.lAutoMemory, CMT_ADD_TEXT, "")+ ;
										CMT_COMMA+CMT_OUTPUT+IIF(.lAutoMemory, CMT_TEXT, CMT_NUMERIC)
								ELSE
									cPortion=m.cPortion+CMT_ARRAY
								ENDIF
							ENDIF
						CASE M_IN=FLOAT_T
							cPortion=m.cPortion+CMT_FLOAT
						CASE M_IN=CHAR_T
							cPortion=m.cPortion+CMT_TEXT
						CASE M_IN=LOGIC_T
							cPortion=m.cPortion+CMT_LOGICAL
						CASE M_IN=BIT_T
							cPortion=m.cPortion+IIF(M_DATA<>BOOL_C OR .lBoolNumeric, ;
								CMT_NUMERIC+CMT_COMMA, CMT_LOGICAL+CMT_COMMA)+M_OUT+ ;
								IIF(VAL(M_OUT)=1, CMT_BIT, CMT_BITS)
						ENDCASE

						IF M_MEMORY
							cPortion=m.cPortion+CMT_COMMA+CMT_MEMORY
						ENDIF
						IF M_DATA=WCHAR_C
							cPortion=m.cPortion+CMT_COMMA+CMT_UNICODE
						ENDIF
						IF M_IN<>BIT_T
							cPortion=m.cPortion+CMT_COMMA+ ;
								IIF(VARTYPE(M_LEN)="N", ;
								LTRIM(STR(IIF(M_IN=CHAR_T AND .lAutoArray, M_LEN*M_NUM, M_LEN))), ;
								"0")+ CMT_BYTES && anche se 1...
						ENDIF
					ENDIF
				ELSE
					WITH EVALUATE(m.cProp)
						lSuccess=.ClipMembers(m.nMode)
					ENDWITH
					IF !m.lSuccess
						.nError=ERR_2_LEVEL_STRUCT && con la forzatura lasci l'errore ma continuo l'elaborazione
						IF INLIST(m.nMode, CLIP_NORMAL, CLIP_INFO)
							_CLIPTEXT=m.cExClip
							RETURN .F.
						ENDIF
					ENDIF

*!* con scala di propriet
*!*				cPortion=Chr(13)+_Cliptext
*!*				cPortion=Strtran(m.cPortion,Chr(13),CRLF+m.cProp,1,Occurs(Chr(13),m.cPortion)-1)

*!* all'interno di With ... Endwith
					cPortion=CRLF+CMT_WITH+m.cProp+ ;
						IIF(INLIST(m.nMode, CLIP_INFO, CLIP_FORCE_AND_INFO), CMT_FLAG+CMT_STRUCTURE+IIF(m.lSuccess, "", CMT_NOT_LOADED), "") + ;
						CRLF + ;
						IIF(m.lSuccess, LEFT(_CLIPTEXT,LEN(_CLIPTEXT)-1), "")+CRLF +CMT_ENDWITH +CRLF
				ENDIF
				cClipString=m.cClipString+m.cPortion+CRLF
			NEXT ii
		NEXT i

*!* finezza finale
		IF INLIST(m.nMode, CLIP_INFO, CLIP_FORCE_AND_INFO)
			cClipString=m.cClipString+CMT_TOTAL+LTRIM(STR(.CalculateBytes()))+CMT_BYTES+CRLF

			IF CMT_1_BYTES$m.cClipString
				cClipString=STRTRAN(m.cClipString, CMT_1_BYTES, CMT_1_BYTE)
			ENDIF
		ENDIF

		cProp=.NULL.
	ENDWITH

	_CLIPTEXT=m.cClipString

	ENDFUNC && fine ClipMembers

	PROTECTED FUNCTION InternalStruct
		LPARAMETERS cStructName
*!* strutture interne caricate in automatico

		cStructName=UPPER(m.cStructName)

		WITH THIS
			DO CASE
			CASE m.cStructName=FT_S
				DIMENSION .aStructMembers[2,9]
				.aStructMembers[1,1]="dwLowDateTime"
				.aStructMembers[2,1]="dwHighDateTime"

			CASE INLIST(m.cStructName, P_S, PL_S)
				DIMENSION .aStructMembers[2,9]
				.aStructMembers[1,1]="x"
				.aStructMembers[2,1]="y"
				.aStructMembers[1,5]=.T. && signed
				.aStructMembers[2,5]=.T.

			CASE INLIST(m.cStructName, R_S, RL_S)
				DIMENSION .aStructMembers[4,9]
				.aStructMembers[1,1]="_left" && qui non controllo i nomi
				.aStructMembers[2,1]="_top"
				.aStructMembers[3,1]="right"
				.aStructMembers[4,1]="bottom"
				.aStructMembers[1,5]=.T. && signed
				.aStructMembers[2,5]=.T.
				.aStructMembers[3,5]=.T.
				.aStructMembers[4,5]=.T.

			CASE m.cStructName=ST_S
				DIMENSION .aStructMembers[8,9]
				.aStructMembers[1,1]="wYear" && sono tutti WORD, li assegno dopo
				.aStructMembers[2,1]="wMonth"
				.aStructMembers[3,1]="wDayOfWeek"
				.aStructMembers[4,1]="wDay"
				.aStructMembers[5,1]="wHour"
				.aStructMembers[6,1]="wMinute"
				.aStructMembers[7,1]="wSecond"
				.aStructMembers[8,1]="wMilliseconds"

			CASE m.cStructName=LI_S && interne per dividere 64 bit integer non supportato da Vfp
				DIMENSION .aStructMembers[2,9]
				.aStructMembers[1,1]="LowPart"
				.aStructMembers[2,1]="HighPart"
				.aStructMembers[2,5]=.T. && signed

			CASE m.cStructName=ULI_S
				DIMENSION .aStructMembers[2,9]
				.aStructMembers[1,1]="LowPart"
				.aStructMembers[2,1]="HighPart"
			OTHERWISE
				.nError=ERR_INVALID_DEF
				.cStructure=""
				RETURN .F.
			ENDCASE

			.nElements=ALEN(.aStructMembers, 1)
			.cStructure=m.cStructName

			PRIVATE i
			FOR	i=1 TO .nElements
				IF m.cStructName<>ST_S
					M_DATA=DWORD_C
					M_LEN=4
				ELSE
					M_DATA=WORD_C
					M_LEN=2
				ENDIF
				M_NUM=1
				STORE NUM_T TO M_IN, M_OUT
			NEXT

			.ResetData()

		ENDWITH
		ENDFUNC && fine InternalStruct

	PROTECTED FUNCTION ExtractMemString(cMemStr, nAddr, nSRead)
*!* Legge la memoria con trap dell'errore. Ora chiama Sys(2600).

		PRIVATE lSuccess, cExErr
		LOCAL lSuccess AS Logical, ;
			cExErr AS STRING

		lSuccess=.T.

		#IF VERSION(5)>=800
			TRY
				cMemStr=SYS(2600, nAddr, m.nSRead)
			CATCH WHEN .T.
				lSuccess=.F.
			ENDTRY
		#ELSE
			cExErr=ON("Error")
			ON ERROR m.lSuccess=.F.
			cMemStr=SYS(2600, nAddr, m.nSRead)
			ON ERROR &cExErr
		#ENDIF

		IF !m.lSuccess
			THIS.nError=ERR_DLL_EXCEPTION
		ENDIF

		RETURN m.lSuccess

		ENDFUNC && fine ExtractMemString

	FUNCTION WriteMemory
*!*	scrive una stringa nel buffer di memoria e ne restituisce l'indirizzo
	LPARAMETERS cMemString, nMemAddr

	WITH THIS
		IF VARTYPE(m.cMemString)<>"C" OR LEN(m.cMemString)=0
			.nError=ERR_BAD_PARAMS
			RETURN 0
		ENDIF

		.nError=ERR_NO_ERROR

		PRIVATE nSize, nMemHandle, cExErr
		LOCAL nSize AS NUMBER, ;
			nMemHandle AS NUMBER, ;
			cExErr AS STRING

		nSize=LEN(m.cMemString)
		nMemHandle=0

		#IF VERSION(5)>=800
			TRY
				nMemHandle=IIF(VARTYPE(m.nMemAddr)<>"N", .AllocateMemory(m.nSize), m.nMemAddr)
				=SYS(2600, m.nMemHandle, m.nSize, m.cMemString)
			CATCH WHEN .T.
				nMemHandle=0
			ENDTRY
		#ELSE
			cExErr=ON("Error")
			ON ERROR m.nMemHandle=0
			nMemHandle=IIF(VARTYPE(m.nMemAddr)<>"N", .AllocateMemory(m.nSize), m.nMemAddr)
			=SYS(2600, m.nMemHandle, m.nSize, m.cMemString)
			ON ERROR &cExErr
		#ENDIF

		IF m.nMemHandle=0
			.nError=ERR_DLL_EXCEPTION
		ENDIF
	ENDWITH

	RETURN m.nMemHandle

	ENDFUNC && fine WriteMemory

	FUNCTION FreeMemory
*!*	libera la memoria allocata da WriteMemory
	LPARAMETERS nMemHandle

	IF VARTYPE(m.nMemHandle)<>"N"
		THIS.nError=ERR_BAD_PARAMS
		RETURN .F.
	ENDIF

	THIS.nError=ERR_NO_ERROR

	PRIVATE nResult, cExErr
	LOCAL nResult AS NUMBER, ;
		cExErr AS STRING

	DECLARE INTEGER HeapFree IN win32api AS _rps_HeapFree ;
		INTEGER hHeap, ;
		INTEGER dwFlags, ;
		INTEGER lpMem

	#IF VERSION(5)>=800
		TRY
			nResult=_rps_HeapFree(THIS.nHeap, 0, m.nMemHandle)
		CATCH WHEN .T.
			nResult=0
		ENDTRY
	#ELSE
		cExErr=ON("Error")
		ON ERROR m.nResult=0
		nResult=_rps_HeapFree(THIS.nHeap, 0, m.nMemHandle)
		ON ERROR &cExErr
	#ENDIF

	RETURN IIF(m.nResult=0, .F., .T.)

	ENDFUNC && fine FreeMemory

	FUNCTION GetMemorySize
*!*	restituisce la lunghezza di memoria allocata
	LPARAMETERS nMemHandle

	IF VARTYPE(m.nMemHandle)<>"N"
		THIS.nError=ERR_BAD_PARAMS
		RETURN 0
	ENDIF

	THIS.nError=ERR_NO_ERROR

	PRIVATE nResult, cExErr
	LOCAL nResult AS Logical, ;
		cExErr AS STRING

	DECLARE INTEGER HeapSize IN win32api AS _rps_HeapSize ;
		INTEGER hHeap, ;
		INTEGER dwFlags, ;
		INTEGER lpMem

	#IF VERSION(5)>=800
		TRY
			nResult=_rps_HeapSize(THIS.nHeap, 0, m.nMemHandle)
		CATCH WHEN .T.
			nResult=0
		ENDTRY
	#ELSE
		cExErr=ON("Error")
		ON ERROR m.nResult=0
		nResult=_rps_HeapSize(THIS.nHeap, 0, m.nMemHandle)
		ON ERROR &cExErr
	#ENDIF

	RETURN m.nResult

	ENDFUNC && fine GetMemorySize

	FUNCTION AllocateMemory
*!*	Alloca tot bytes di memoria
	LPARAMETERS nBytes

	WITH THIS
		IF VARTYPE(m.nBytes)<>"N" OR m.nBytes<1
			.nError=ERR_BAD_PARAMS
			RETURN 0
		ENDIF

		.nError=ERR_NO_ERROR

		DECLARE INTEGER HeapAlloc IN win32api AS _rps_HeapAlloc ;
			INTEGER hHeap, ;
			INTEGER dwFlags, ;
			INTEGER dwBytes

		PRIVATE nResult
		LOCAL nResult AS NUMBER

		nResult=_rps_HeapAlloc(.nHeap, HEAP_ZERO_MEMORY, m.nBytes) && non  necessario metterla a 0 ma ...
	ENDWITH

	RETURN m.nResult

	ENDFUNC && fine AllocateMemory

	FUNCTION InitAPIArray
*!*	carica una matrice API di un dato o di una struttura come se fosse una struttura
	LPARAMETERS cDataType, nElements, cElementName

	WITH THIS
		.nError=ERR_NO_ERROR

		IF EMPTY(m.cDataType) ;
				OR (!EMPTY(m.nElements) AND VARTYPE(m.nElements)<>"N") ;
				OR (VARTYPE(m.nElements)="N" AND m.nElements<1) ;
				OR (!EMPTY(m.cElementName) AND VARTYPE(m.cElementName)<>"C")

			.nError=ERR_BAD_PARAMS
			RETURN .F.
		ELSE && concedo l'inidice per le strutture interne
			IF VARTYPE(m.cDataType)<>"C"
				IF VARTYPE(m.cDataType)="N" AND BETWEEN(m.cDataType, 1, GETWORDCOUNT(.DataTypes(DATA_INT_STRUCT)))
					cDataType=(GETWORDNUM(.DataTypes(DATA_INT_STRUCT), INT(m.cDataType)))
				ELSE
					.nError=ERR_BAD_PARAMS
					RETURN .F.
				ENDIF
			ENDIF
		ENDIF

		IF EMPTY(m.nElements)
			nElements=1
		ENDIF

		IF EMPTY(m.cElementName)
			cElementName=m.cDataType
		ENDIF

		PRIVATE cArrayDef, lExUnknownAsStruct, lCreated
		LOCAL cArrayDef AS STRING, ;
			lExUnknownAsStruct AS Logical, ;
			lCreated AS Logical

		cArrayDef=TOP_API_ARRAY+CRLF+ ;
			m.cDataType+" "+m.cElementName+"["+LTRIM(STR(m.nElements))+"]"+SEMICOLON+ ;
			CRLF+END_API_ARRAY

		lExUnknownAsStruct=.lUnknownAsStruct
		.lUnknownAsStruct=.T.

		lCreated=.LoadCDef(m.cArrayDef)

		.lUnknownAsStruct=m.lExUnknownAsStruct
		IF !m.lExUnknownAsStruct
			.SetSub("lUnknownAsStruct", m.lExUnknownAsStruct) && ereditano solo eventuali strutture
		ENDIF
		IF .GetLast()>0
			.vStopAt=.vStopAt && assegna alle strutture, se ci sono
		ENDIF
		IF .nPadding<>PADDING_NONE
			.nPadding=.nPadding && idem come sopra
		ENDIF
		IF !EMPTY(.cDoubleNullList)
			.cDoubleNullList=.cDoubleNullList
		ENDIF
		IF !EMPTY(.cExcludeList)
			.cExcludeList=.cExcludeList
		ENDIF

		RETURN m.lCreated

	ENDWITH

	ENDFUNC && fine InitAPIArray

	FUNCTION GetPtr
*!*	restituisce il puntatore per le stringhe scritte da MakeStruct() o tornate da SplitStruct()
	LPARAMETERS cMemberName, nIndex

	WITH THIS
		.nError=ERR_NO_ERROR

		DO CASE
		CASE .nElements=0
			.nError=ERR_DEF_NOT_LOADED
		CASE VARTYPE(m.cMemberName)<>"C" OR EMPTY(m.cMemberName)
			.nError=ERR_BAD_PARAMS
		CASE VARTYPE(IIF(.lMakeIsLast, .aPtrsIn[1], .aPtrsOut[1]))="L"
			.nError=ERR_NO_STORED_POINTERS
		ENDCASE

		IF .nError<>ERR_NO_ERROR
			RETURN GETPTR_FAILS
		ENDIF

		IF VARTYPE(m.nIndex)<>"N" OR EMPTY(m.nIndex)
			nIndex=1
		ENDIF

		PRIVATE i, cPtrString, nReturned
		LOCAL cPtrString AS STRING, ;
			nReturned AS NUMBER

		i=ASCAN(.aStructMembers, m.cMemberName, 1, .nElements, 1, 15) && numero di riga

*!*	controllo elemento
		DO CASE
		CASE m.i=0
			.nError=ERR_MEMBER_NOT_FOUND
*!*	controllo indice
		CASE m.nIndex>1 AND TYPE(["]+M_NAME+"["+LTRIM(STR(m.nIndex))+']"')="U"
			.nError=ERR_BAD_MEMBER_INDEX
*!*	controllo se puntatore
		CASE !M_MEMORY
			.nError=ERR_NO_POINTER
		ENDCASE
		IF .nError<>ERR_NO_ERROR
			RETURN GETPTR_FAILS
		ENDIF

*!*  puntatore ma vuoto
		cPtrString=IIF(.lMakeIsLast, M_POINTER_IN, M_POINTER_OUT)
		nReturned=INT(VAL(GETWORDNUM(m.cPtrString, m.nIndex)))

		IF m.nReturned>0
			RETURN m.nReturned
		ENDIF
		.nError=ERR_MEMORY_NOT_POINTED
		RETURN GETPTR_FAILS

	ENDWITH

	ENDFUNC && fine GetPtr

	FUNCTION FlagTest
*!*	ritorna .T. se un determinato numero  presente in un altro come flag di bit
	LPARAMETERS nIntValue, nFlag
	WITH THIS
		IF PCOUNT()<2 ;
				OR VARTYPE(m.nFlag)<>"N" OR VARTYPE(m.nIntValue)<>"N"
			.nError=ERR_BAD_PARAMS
			RETURN .F.
		ENDIF

		.nError=ERR_NO_ERROR

	ENDWITH

	RETURN (BITAND(m.nIntValue, m.nFlag)=INT(m.nFlag))

	ENDFUNC && fine FlagTest

	PROTECTED FUNCTION SetSub(cProperty, eValue)
*!*	setta le propriet delle classi delle sub-strutture
		WITH THIS

			IF .nElements=0
				RETURN .F.
			ENDIF

			PRIVATE i, ii, cProp

			FOR i=1 TO ALEN(.aStructMembers,1)
				IF M_IN=STRUCT_T
					FOR ii=1 TO M_NUM
						cProp=DOT+M_NAME+IIF(!M_ARRAY, "", ADD_ARRAY)
						WITH EVALUATE(m.cProp)
							STORE m.eValue TO (DOT+m.cProperty)
						ENDWITH
					NEXT
				ENDIF
			NEXT
			cProp=.NULL.

		ENDWITH

		ENDFUNC && fine SetSub

	PROTECTED FUNCTION ReleasePointers
*!*	rilascia la memoria scritta dalla classe
		PRIVATE i, ii
		FOR i=1 TO .nElements
			IF !EMPTY(M_POINTER_IN)
				FOR ii=1 TO GETWORDCOUNT(M_POINTER_IN)
					.FreeMemory(VAL(GETWORDNUM(M_POINTER_IN, m.ii)))
				NEXT
			ENDIF
		NEXT
		ENDFUNC && fine ReleasePointers

	PROTECTED FUNCTION GetLast
*!*	ritorna l'ultimo elemento da elaborare

		WITH THIS

			PRIVATE cTypeVal, nRetVal
			LOCAL cTypeVal AS STRING, ;
				nRetVal AS NUMBER

			cTypeVal=VARTYPE(.vStopAt)
			DO CASE
			CASE m.cTypeVal="N"
				nRetVal=.vStopAt

			CASE m.cTypeVal="C"
				nRetVal=ASCAN(.aStructMembers, .vStopAt, 1, .nElements, 1, 15)

			OTHERWISE && impossibile
				nRetVal=0
			ENDCASE

			nRetVal=IIF(m.nRetVal>0, MIN(m.nRetVal, .nElements), .nElements)
		ENDWITH

		RETURN m.nRetVal

		ENDFUNC

	PROCEDURE DESTROY
*!* solo se la classe ha allocato memoria
	WITH THIS
		IF VARTYPE(.aPtrsIn[1])<>"L"
			.ReleasePointers()
		ENDIF
	ENDWITH

	CLEAR DLLS "_rps_GetProcessHeap"
	CLEAR DLLS "_rps_HeapAlloc"
	CLEAR DLLS "_rps_GlobalLock"
	CLEAR DLLS "_rps_GlobalUnlock"
	CLEAR DLLS "_rps_HeapSize"
	CLEAR DLLS "_rps_HeapFree"
	ENDPROC && fine Destroy

	PROCEDURE INIT

	DECLARE INTEGER GetProcessHeap IN win32api AS _rps_GetProcessHeap
	THIS.nHeap=_rps_GetProcessHeap()

	ENDPROC && fine Init

	PROCEDURE lAllowIntStruct_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lAllowIntStruct=m.vNewVal
	ENDIF
	ENDPROC && fine lAllowIntStruct_ASSIGN

	PROCEDURE lBoolNumeric_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lBoolNumeric=m.vNewVal
	ENDIF
	ENDPROC && fine lBoolNumeric_ASSIGN

	PROCEDURE lSplit64bit_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lSplit64bit=m.vNewVal
	ENDIF
	ENDPROC && fine lSplit64bit_ASSIGN

	PROCEDURE lAutoArray_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lAutoArray=m.vNewVal
	ENDIF
	ENDPROC && fine lAutoArray_ASSIGN

	PROCEDURE lAutoMemory_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" && And This.nElements=0
		THIS.lAutoMemory=m.vNewVal
		THIS.SetSub("lAutoMemory", m.vNewVal)
	ENDIF
	ENDPROC && fine lAutoMemory_ASSIGN

	PROCEDURE lUnknownAsStruct_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lUnknownAsStruct=m.vNewVal
	ENDIF
	ENDPROC && fine lUnknownAsStruct_ASSIGN

	PROCEDURE nPadding_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="N" ;
			AND m.vNewVal>=PADDING_AUTO
		THIS.nPadding=INT(m.vNewVal)
		IF THIS.nElements=1 AND THIS.aStructMembers[1,6]=STRUCT_T
			THIS.SetSub("nPadding", m.vNewVal) && eredito solo se array di strutture
		ENDIF
	ENDIF
	ENDPROC && fine nPadding_ASSIGN

	PROCEDURE vStopAt_ASSIGN
	LPARAMETERS vNewVal

	PRIVATE cTypeVal
	LOCAL cTypeVal AS NUMBER

	cTypeVal=VARTYPE(m.vNewVal)

	IF INLIST(m.cTypeVal, "N", "C")
		DO CASE
		CASE m.cTypeVal="N"
			vNewVal=INT(MAX(m.vNewVal, 0))
		CASE m.cTypeVal="C"
			IF !EMPTY(m.vNewVal)
				vNewVal=CHRTRAN(m.vNewVal, " .;*"+TABU+CRLF, "") && tutti i possibili errori di copiatura
				IF "["$m.vNewVal
					vNewVal=STREXTRACT(m.vNewVal, "", "[")
				ENDIF
				IF "("$m.vNewVal
					vNewVal=STREXTRACT(m.vNewVal, "", "(")
				ENDIF
			ELSE
				vNewVal=""
			ENDIF
		ENDCASE

		THIS.vStopAt=m.vNewVal
		IF THIS.nElements=1 AND THIS.aStructMembers[1,6]=STRUCT_T
			THIS.SetSub("vStopAt", m.vNewVal) && come sopra
		ENDIF
	ENDIF

	ENDPROC && fine vStopAt_ASSIGN

	PROCEDURE cDoubleNullList_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="C"
		vNewVal=IIF(!EMPTY(m.vNewVal), CHRTRAN(m.vNewVal, ",. *[]()"+CHR(0)+TABU, ";;;;;;;;;;"), "") && possibili errori di separazione o copiatura
		THIS.cDoubleNullList=m.vNewVal
		IF THIS.nElements=1 AND THIS.aStructMembers[1,6]=STRUCT_T
			THIS.SetSub("cDoubleNullList", m.vNewVal) && come sopra
		ENDIF
	ENDIF
	ENDPROC && fine cDoubleNullList_ASSIGN

	PROCEDURE lAutoUnicodeConv_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" && And This.nElements=0
		THIS.lAutoUnicodeConv=m.vNewVal
		THIS.SetSub("lAutoUnicodeConv", m.vNewVal) && come sopra
	ENDIF
	ENDPROC && fine lAutoUnicodeConv_ASSIGN

	PROCEDURE cExcludeList_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="C"
		vNewVal=IIF(!EMPTY(m.vNewVal), CHRTRAN(m.vNewVal, ",. *[]()"+CHR(0)+TABU, ";;;;;;;;;;"), "") && possibili errori di separazione o copiatura
		THIS.cExcludeList=m.vNewVal
		IF THIS.nElements=1 AND THIS.aStructMembers[1,6]=STRUCT_T
			THIS.SetSub("cExcludeList", m.vNewVal) && come sopra
		ENDIF
	ENDIF
	ENDPROC && fine cExcludeList_ASSIGN

	PROCEDURE lAutoFar_ASSIGN
	LPARAMETERS vNewVal

	IF VARTYPE(m.vNewVal)="L" AND THIS.nElements=0
		THIS.lAutoFar=m.vNewVal
	ENDIF
	ENDPROC && fine lAutoFar_ASSIGN

	PROCEDURE getaddr
	oPChar = CREATEOBJECT("pchar",THIS.MakeStruct()) && pchar.prg
	RETURN oPChar.getaddr()
	ENDPROC
ENDDEFINE
